# common make file for the APG library
#
.SUFFIXES:
.SUFFIXES: .c .cpp .o
#
SHELL  = /bin/sh
SRCDIR = .
PUBDIR = ../public
OBJDIR = $(SRCDIR)/$(OBJNAME)
LIB    = $(PUBLIC)/$(LIBNAME)
UTILIB = ($PUBLIC)/$(UTILNAME)
CFLAGS = -I../ApgLib -I$(PUBDIR)
LFLAGS = -L$(PUBDIR)
EXE    = $(PUBDIR)/$(EXENAME)
OBJS   = $(OBJDIR)/CommandLine.o \
         $(OBJDIR)/Display.o \
         $(OBJDIR)/Errors.o \
         $(OBJDIR)/Generator.o \
         $(OBJDIR)/Grammar.o \
         $(OBJDIR)/Lexer.o \
         $(OBJDIR)/main.o \
         $(OBJDIR)/NonPPTOpcodes.o \
         $(OBJDIR)/Parser.o \
         $(OBJDIR)/PPTLexer.o \
         $(OBJDIR)/PPTOpcodes.o \
         $(OBJDIR)/PPTParser.o \
         $(OBJDIR)/SEST.o \
         $(OBJDIR)/SESTWalker.o
#
# build all
all : $(OBJDIR) $(OBJS) $(EXE)
#
# create the directories, if neccessary
$(OBJDIR) :
	mkdir $(OBJDIR)
	chmod 755 $(OBJDIR)
#
$(EXE) : $(OBJS)
	$(CC) -o $(EXE) $(OBJS) $(LFLAGS) -l$(LIBNAME) -l$(UTILNAME)
#
# implicit rules
$(OBJDIR)/%.o: $(SRCDIR)/%.c
	$(CC) -c $(CFLAGS) $(<) -o $(@)
#
#clean  
.PHONY : clean
clean :
	rm $(OBJDIR)/*
	rm $(EXE)
