/********************************************************************
  APG - an ABNF Parser Generator
  Copyright  (C) 2007 Coast to Coast Research, Inc.
 
  This program is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 2 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program.  If not, see
  <http://www.gnu.org/licenses/old-licenses/gpl-2.0.html>
  or write to the Free Software Foundation, Inc.,
  51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
  
	 created: Sat Nov 24 14:09:33 2007
	filename: PPTLexer.h
	  author: Lowell Thomas
	          lowell@coasttocoastresearch.com
	          http://www.coasttocoastresearch.com

	 purpose: Header file for parser PPTLexer.

*********************************************************************/
#ifndef PPTLexer_h
#define PPTLexer_h

//{{header.pre
//}}header.pre

// rule name IDs
#define RULE_PPTLEXER_FILE 0
#define RULE_PPTLEXER_LINE 1
#define RULE_PPTLEXER_BLANK 2
#define RULE_PPTLEXER_LINEERROR 3
#define RULE_PPTLEXER_RULE 4
#define RULE_PPTLEXER_NAMEDEF 5
#define RULE_PPTLEXER_DEFALT 6
#define RULE_PPTLEXER_DEF 7
#define RULE_PPTLEXER_NAMEDEFERROR 8
#define RULE_PPTLEXER_DEFERROR 9
#define RULE_PPTLEXER_OPALT 10
#define RULE_PPTLEXER_OPNOT 11
#define RULE_PPTLEXER_OPAND 12
#define RULE_PPTLEXER_OPRPAREN 13
#define RULE_PPTLEXER_OPROPTION 14
#define RULE_PPTLEXER_OPCAT 15
#define RULE_PPTLEXER_OPLPAREN 16
#define RULE_PPTLEXER_OPLOPTION 17
#define RULE_PPTLEXER_OPREP 18
#define RULE_PPTLEXER_OPNUMBER 19
#define RULE_PPTLEXER_DRANGE 20
#define RULE_PPTLEXER_DSTRING 21
#define RULE_PPTLEXER_DCHAR 22
#define RULE_PPTLEXER_XRANGE 23
#define RULE_PPTLEXER_XSTRING 24
#define RULE_PPTLEXER_XCHAR 25
#define RULE_PPTLEXER_BRANGE 26
#define RULE_PPTLEXER_BSTRING 27
#define RULE_PPTLEXER_BCHAR 28
#define RULE_PPTLEXER_NAME 29
#define RULE_PPTLEXER_OPTLS 30
#define RULE_PPTLEXER_PROSVAL 31
#define RULE_PPTLEXER_TOKENERROR 32
#define RULE_PPTLEXER_TOKEN 33
#define RULE_PPTLEXER_OPDEC 34
#define RULE_PPTLEXER_OPHEX 35
#define RULE_PPTLEXER_OPBIN 36
#define RULE_PPTLEXER_DMIN 37
#define RULE_PPTLEXER_DMAX 38
#define RULE_PPTLEXER_DNUM 39
#define RULE_PPTLEXER_BMIN 40
#define RULE_PPTLEXER_BMAX 41
#define RULE_PPTLEXER_BNUM 42
#define RULE_PPTLEXER_XMIN 43
#define RULE_PPTLEXER_XMAX 44
#define RULE_PPTLEXER_XNUM 45
#define RULE_PPTLEXER_ALPHA 46
#define RULE_PPTLEXER_WSP 47
#define RULE_PPTLEXER_COMMENT 48
#define RULE_PPTLEXER_LINECONTIN 49
#define RULE_PPTLEXER_LINEEND 50
#define RULE_PPTLEXER_BLANKLINEEND 51

extern void* vpPPTLexerInit;

//{{header.post
//}}header.post

#endif // PPTLexer_h
