/********************************************************************
  APG - an ABNF Parser Generator
  Copyright  (C) 2007 Coast to Coast Research, Inc.
 
  This program is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 2 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program.  If not, see
  <http://www.gnu.org/licenses/old-licenses/gpl-2.0.html>
  or write to the Free Software Foundation, Inc.,
  51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

    author: Lowell Thomas
            lowell@coasttocoastresearch.com
            http://www.coasttocoastresearch.com

   created: 10/2/2007 8:20
  filename: D:\Projects\Apgv5_0\Samples\IPv6\IPv6Data.h
      purpose:	Defines the IPv6 data structure, used by many
                programs, in one place.
  
*********************************************************************/
#ifndef IPv6Data_h_6_20_2007
#define IPv6Data_h_6_20_2007

#define IPV6_OK     0
#define IPV6_SYNTAX 0xFFFFFFFF

typedef struct
{
  char*     cpSrc;            // pointer to the original text representation of the address
  ulong     ulNotValid;
  ulong     ulIsMulticast;
  ulong     ulIsCompressed;
  ulong     ulHasIPv4;
  ulong     ulHasPrefix;
  ulong     ulPrefixLength;
  ulong     ulIndex;
  ulong     ulaBinary[IPV6_SHORTS];
  ushort    usaSections[IPV6_SHORTS];
  ulong     ul4Index;
  uchar     ucaIPv4[IPV4_OCTETS];
} IPV6CTX;

#endif /* IPv6Data_h_6_20_2007 */
