/********************************************************************
  APG - an ABNF Parser Generator
  Copyright  (C) 2007 Coast to Coast Research, Inc.
 
  This program is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 2 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program.  If not, see
  <http://www.gnu.org/licenses/old-licenses/gpl-2.0.html>
  or write to the Free Software Foundation, Inc.,
  51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
  
	 created: Thu Nov 22 11:06:49 2007
	filename: IPv6LookAhead.c
	  author: Lowell Thomas
	          lowell@coasttocoastresearch.com
	          http://www.coasttocoastresearch.com

	 purpose: Implementation of parser component IPv6LookAhead.

*********************************************************************/
#include "Apg.h"

//{{Include.pre
//}}Include.pre

#include "IPv6LookAhead.h"

//{{Include.post
//}}Include.post

//  GENERAL INFORMATION:
//       static data = 4636 (bytes)
//                   = 4.53E+00 (KB)
//                   = 4.42E-03 (MB)
//   character count = 103 (grammar alphabet character set)
// unused characters = 78 (grammar alphabet character set)
//        rule count = 41
//      opcode count = 258
//         ALT count = 19(71) (alternations)
//         CAT count = 44(109) (concatenations)
//         RNM count = 113
//         REP count = 37
//         PRD count = 0
//         TRG count = 9
//         TBS count = 0
//         TLS count = 36
//      string table = 400 (bytes)
//           opcodes = 3172 (bytes)
//         rule list = 820 (bytes)
//              PPTs = <not used>

// CALL BACK FUNCTION DECLARATIONS
static ulong pfn_IPv6Address(void* vpData, ulong ulState, ulong ulOffset, ulong ulLen);
static ulong pfn_FormIPv4(void* vpData, ulong ulState, ulong ulOffset, ulong ulLen);
static ulong pfn_Compressed4(void* vpData, ulong ulState, ulong ulOffset, ulong ulLen);
static ulong pfn_First4(void* vpData, ulong ulState, ulong ulOffset, ulong ulLen);
static ulong pfn_Middle41(void* vpData, ulong ulState, ulong ulOffset, ulong ulLen);
static ulong pfn_Middle42(void* vpData, ulong ulState, ulong ulOffset, ulong ulLen);
static ulong pfn_Middle43(void* vpData, ulong ulState, ulong ulOffset, ulong ulLen);
static ulong pfn_Middle44(void* vpData, ulong ulState, ulong ulOffset, ulong ulLen);
static ulong pfn_Compressed6(void* vpData, ulong ulState, ulong ulOffset, ulong ulLen);
static ulong pfn_First6(void* vpData, ulong ulState, ulong ulOffset, ulong ulLen);
static ulong pfn_Middle61(void* vpData, ulong ulState, ulong ulOffset, ulong ulLen);
static ulong pfn_Middle62(void* vpData, ulong ulState, ulong ulOffset, ulong ulLen);
static ulong pfn_Middle63(void* vpData, ulong ulState, ulong ulOffset, ulong ulLen);
static ulong pfn_Middle64(void* vpData, ulong ulState, ulong ulOffset, ulong ulLen);
static ulong pfn_Middle65(void* vpData, ulong ulState, ulong ulOffset, ulong ulLen);
static ulong pfn_Middle66(void* vpData, ulong ulState, ulong ulOffset, ulong ulLen);
static ulong pfn_HEXC(void* vpData, ulong ulState, ulong ulOffset, ulong ulLen);
static ulong pfn_MULTIDIG(void* vpData, ulong ulState, ulong ulOffset, ulong ulLen);

// CALL BACK FUNCTION POINTERS
static ulong g_ulCallbacks = 18;
static PFN_CALLBACK g_pfnCallbacks[18] = 
{
  pfn_IPv6Address,
  pfn_FormIPv4,
  pfn_Compressed4,
  pfn_First4,
  pfn_Middle41,
  pfn_Middle42,
  pfn_Middle43,
  pfn_Middle44,
  pfn_Compressed6,
  pfn_First6,
  pfn_Middle61,
  pfn_Middle62,
  pfn_Middle63,
  pfn_Middle64,
  pfn_Middle65,
  pfn_Middle66,
  pfn_HEXC,
  pfn_MULTIDIG,
};

// EXECUTABLE DATA
static ulong g_ulaExeData[1118] = 
{
  0x00001178,0x617D3033,0x00000000,0x00000029,0x00000102,0x00000067,0x00000000,0x00000067,
  0x00000066,0x00000000,0x00000000,0x00000050,0x00000050,0x00000190,0x000001E0,0x00000C64,
  0x00000E44,0x00000334,0x00000000,0x00000000,0x36765049,0x72646441,0x00737365,0x36765049,
  0x63696E55,0x00747361,0x726F462F,0x7650496D,0x6F430034,0x6572706D,0x64657373,0x69460034,
  0x34747372,0x73614C00,0x4D003474,0x6C646469,0x00313465,0x6464694D,0x3234656C,0x64694D00,
  0x34656C64,0x694D0033,0x656C6464,0x46003434,0x346C6C75,0x726F4600,0x7650496D,0x6F430036,
  0x6572706D,0x64657373,0x69460036,0x36747372,0x73614C00,0x4D003674,0x6C646469,0x00313665,
  0x6464694D,0x3236656C,0x64694D00,0x36656C64,0x694D0033,0x656C6464,0x4D003436,0x6C646469,
  0x00353665,0x6464694D,0x3636656C,0x6C754600,0x4900366C,0x4D367650,0x69746C75,0x74736163,
  0x6F462F00,0x494D6D72,0x00347650,0x706D6F43,0x73736572,0x344D6465,0x6C754600,0x00344D6C,
  0x726F463A,0x50494D6D,0x43003676,0x72706D6F,0x65737365,0x00364D64,0x6C6C7546,0x3A00364D,
  0x34765049,0x72646441,0x00737365,0x6572502E,0x4C786966,0x74676E65,0x45480068,0x43003458,
  0x00504D4F,0x45483A3A,0x3A004358,0x58454843,0x554D3A00,0x4449544C,0x66004749,0x47494466,
  0x00375449,0x2D534F50,0x49474944,0x4E490054,0x35353254,0x30353200,0x34333231,0x31303235,
  0x31343332,0x30303030,0x49443030,0x00544947,0x44584548,0x61004749,0x65646362,0x00000066,
  0x00000001,0x00000020,0x00000000,0x00000014,0x00000016,0x00000000,0x00000020,0x00000001,
  0x00000001,0x00000090,0x00000002,0x00000048,0x00000000,0x0000003C,0x00000002,0x00000000,
  0x00000048,0x0000001D,0x00000002,0x00000090,0x00000000,0x0000005C,0x0000000B,0x00000003,
  0x00000090,0x00000000,0x00000001,0x00000002,0x00000090,0x00000007,0x00000084,0x00000018,
  0x00000001,0x00000000,0x00000090,0x0000001E,0x00000001,0x000000B0,0x00000000,0x000000A4,
  0x00000003,0x00000000,0x000000B0,0x0000000A,0x00000001,0x0000011C,0x00000000,0x000000C4,
  0x00000004,0x00000002,0x0000011C,0x00000000,0x000000D8,0x0000001F,0x00000001,0x0000011C,
  0x00000000,0x000000EC,0x00000006,0x00000000,0x000000F8,0x00000007,0x00000000,0x00000104,
  0x00000008,0x00000000,0x00000110,0x00000009,0x00000000,0x0000011C,0x00000005,0x00000002,
  0x0000014C,0x00000000,0x00000130,0x00000020,0x00000003,0x0000014C,0x00000000,0x00000005,
  0x00000000,0x0000014C,0x00000021,0x00000002,0x0000017C,0x00000003,0x00000170,0x00000000,
  0x00000004,0x00000000,0x00000170,0x00000022,0x00000000,0x0000017C,0x00000020,0x00000002,
  0x000001AC,0x00000000,0x00000190,0x00000020,0x00000003,0x000001AC,0x00000001,0x00000004,
  0x00000000,0x000001AC,0x00000021,0x00000002,0x000001E8,0x00000000,0x000001C0,0x00000022,
  0x00000000,0x000001CC,0x00000020,0x00000003,0x000001E8,0x00000001,0x00000003,0x00000000,
  0x000001E8,0x00000021,0x00000002,0x00000234,0x00000003,0x0000020C,0x00000002,0x00000002,
  0x00000000,0x0000020C,0x00000022,0x00000000,0x00000218,0x00000020,0x00000003,0x00000234,
  0x00000001,0x00000002,0x00000000,0x00000234,0x00000021,0x00000002,0x00000270,0x00000003,
  0x00000258,0x00000003,0x00000003,0x00000000,0x00000258,0x00000022,0x00000000,0x00000264,
  0x00000020,0x00000000,0x00000270,0x00000021,0x00000003,0x0000028C,0x00000006,0x00000006,
  0x00000000,0x0000028C,0x00000021,0x00000001,0x000002AC,0x00000000,0x000002A0,0x0000000C,
  0x00000000,0x000002AC,0x00000015,0x00000001,0x00000330,0x00000000,0x000002C0,0x0000000D,
  0x00000002,0x00000330,0x00000000,0x000002D4,0x0000001F,0x00000001,0x00000330,0x00000000,
  0x000002E8,0x0000000F,0x00000000,0x000002F4,0x00000010,0x00000000,0x00000300,0x00000011,
  0x00000000,0x0000030C,0x00000012,0x00000000,0x00000318,0x00000013,0x00000000,0x00000324,
  0x00000014,0x00000000,0x00000330,0x0000000E,0x00000002,0x00000384,0x00000000,0x00000344,
  0x00000020,0x00000003,0x00000384,0x00000000,0x00000001,0x00000002,0x00000384,0x00000003,
  0x00000378,0x00000000,0x00000006,0x00000000,0x00000378,0x00000021,0x00000000,0x00000384,
  0x0000001F,0x00000002,0x000003B4,0x00000003,0x000003A8,0x00000000,0x00000006,0x00000000,
  0x000003A8,0x00000022,0x00000000,0x000003B4,0x00000020,0x00000002,0x000003F0,0x00000000,
  0x000003C8,0x00000020,0x00000003,0x000003E4,0x00000000,0x00000005,0x00000000,0x000003E4,
  0x00000021,0x00000000,0x000003F0,0x0000001F,0x00000002,0x00000438,0x00000000,0x00000404,
  0x00000022,0x00000000,0x00000410,0x00000020,0x00000003,0x0000042C,0x00000000,0x00000004,
  0x00000000,0x0000042C,0x00000021,0x00000000,0x00000438,0x0000001F,0x00000002,0x00000490,
  0x00000003,0x0000045C,0x00000002,0x00000002,0x00000000,0x0000045C,0x00000022,0x00000000,
  0x00000468,0x00000020,0x00000003,0x00000484,0x00000000,0x00000003,0x00000000,0x00000484,
  0x00000021,0x00000000,0x00000490,0x0000001F,0x00000002,0x000004E8,0x00000003,0x000004B4,
  0x00000003,0x00000003,0x00000000,0x000004B4,0x00000022,0x00000000,0x000004C0,0x00000020,
  0x00000003,0x000004DC,0x00000000,0x00000002,0x00000000,0x000004DC,0x00000021,0x00000000,
  0x000004E8,0x0000001F,0x00000002,0x00000540,0x00000003,0x0000050C,0x00000004,0x00000004,
  0x00000000,0x0000050C,0x00000022,0x00000000,0x00000518,0x00000020,0x00000003,0x00000534,
  0x00000000,0x00000001,0x00000000,0x00000534,0x00000021,0x00000000,0x00000540,0x0000001F,
  0x00000002,0x0000057C,0x00000003,0x00000564,0x00000005,0x00000005,0x00000000,0x00000564,
  0x00000022,0x00000000,0x00000570,0x00000020,0x00000000,0x0000057C,0x0000001F,0x00000002,
  0x000005AC,0x00000003,0x000005A0,0x00000007,0x00000007,0x00000000,0x000005A0,0x00000021,
  0x00000000,0x000005AC,0x0000001F,0x00000001,0x0000061C,0x00000002,0x000005D4,0x00000000,
  0x000005C8,0x00000017,0x00000000,0x000005D4,0x0000001D,0x00000002,0x0000061C,0x00000000,
  0x000005E8,0x0000001A,0x00000003,0x0000061C,0x00000000,0x00000001,0x00000002,0x0000061C,
  0x00000007,0x00000610,0x000000D1,0x00000001,0x00000000,0x0000061C,0x0000001E,0x00000001,
  0x0000063C,0x00000000,0x00000630,0x00000018,0x00000000,0x0000063C,0x00000019,0x00000002,
  0x00000694,0x00000000,0x00000650,0x00000023,0x00000001,0x00000694,0x00000000,0x00000664,
  0x00000006,0x00000000,0x00000670,0x00000007,0x00000000,0x0000067C,0x00000008,0x00000000,
  0x00000688,0x00000009,0x00000000,0x00000694,0x00000005,0x00000002,0x000006D4,0x00000000,
  0x000006A8,0x00000023,0x00000007,0x000006B8,0x000000F0,0x00000001,0x00000003,0x000006D4,
  0x00000005,0x00000005,0x00000000,0x000006D4,0x00000021,0x00000001,0x000006F4,0x00000000,
  0x000006E8,0x0000001B,0x00000000,0x000006F4,0x0000001C,0x00000002,0x00000764,0x00000000,
  0x00000708,0x00000023,0x00000001,0x00000764,0x00000000,0x0000071C,0x0000000F,0x00000000,
  0x00000728,0x00000010,0x00000000,0x00000734,0x00000011,0x00000000,0x00000740,0x00000012,
  0x00000000,0x0000074C,0x00000013,0x00000000,0x00000758,0x00000014,0x00000000,0x00000764,
  0x0000000E,0x00000002,0x000007B0,0x00000000,0x00000778,0x00000023,0x00000007,0x00000788,
  0x0000010F,0x00000001,0x00000003,0x000007A4,0x00000006,0x00000006,0x00000000,0x000007A4,
  0x00000021,0x00000000,0x000007B0,0x0000001F,0x00000002,0x000007F8,0x00000000,0x000007C4,
  0x00000026,0x00000003,0x000007F8,0x00000003,0x00000003,0x00000002,0x000007F8,0x00000007,
  0x000007EC,0x0000011C,0x00000001,0x00000000,0x000007F8,0x00000026,0x00000001,0x000008B0,
  0x00000002,0x00000834,0x00000005,0x00000818,0x00000031,0x00000031,0x00000005,0x00000828,
  0x00000032,0x00000032,0x00000000,0x00000834,0x00000024,0x00000002,0x00000880,0x00000005,
  0x0000084C,0x00000031,0x00000031,0x00000001,0x00000874,0x00000005,0x00000864,0x00000030,
  0x00000030,0x00000005,0x00000874,0x00000031,0x00000031,0x00000000,0x00000880,0x00000027,
  0x00000002,0x000008B0,0x00000000,0x00000894,0x00000025,0x00000003,0x000008B0,0x00000000,
  0x00000001,0x00000000,0x000008B0,0x00000027,0x00000003,0x000008CC,0x00000001,0x00000004,
  0x00000000,0x000008CC,0x00000028,0x00000007,0x000008DC,0x00000134,0x00000002,0x00000002,
  0x00000910,0x00000003,0x00000900,0x00000001,0x00000004,0x00000000,0x00000900,0x00000028,
  0x00000007,0x00000910,0x0000013B,0x00000001,0x00000002,0x00000944,0x00000007,0x00000928,
  0x00000141,0x00000001,0x00000003,0x00000944,0x00000001,0x00000004,0x00000000,0x00000944,
  0x00000028,0x00000002,0x00000978,0x00000007,0x0000095C,0x0000014B,0x00000002,0x00000003,
  0x00000978,0x00000002,0x00000002,0x00000000,0x00000978,0x00000028,0x00000005,0x00000988,
  0x00000030,0x00000037,0x00000005,0x00000998,0x00000031,0x00000039,0x00000001,0x00000BDC,
  0x00000002,0x00000A30,0x00000007,0x000009B8,0x00000165,0x00000001,0x00000007,0x000009C8,
  0x00000166,0x00000001,0x00000001,0x00000A30,0x00000007,0x000009E0,0x00000167,0x00000001,
  0x00000007,0x000009F0,0x00000168,0x00000001,0x00000007,0x00000A00,0x00000169,0x00000001,
  0x00000007,0x00000A10,0x0000016A,0x00000001,0x00000007,0x00000A20,0x0000016B,0x00000001,
  0x00000007,0x00000A30,0x0000016C,0x00000001,0x00000002,0x00000AAC,0x00000007,0x00000A48,
  0x0000016D,0x00000001,0x00000001,0x00000AA0,0x00000007,0x00000A60,0x0000016E,0x00000001,
  0x00000007,0x00000A70,0x0000016F,0x00000001,0x00000007,0x00000A80,0x00000170,0x00000001,
  0x00000007,0x00000A90,0x00000171,0x00000001,0x00000007,0x00000AA0,0x00000172,0x00000001,
  0x00000000,0x00000AAC,0x00000027,0x00000002,0x00000AE0,0x00000007,0x00000AC4,0x00000173,
  0x00000001,0x00000003,0x00000AE0,0x00000002,0x00000002,0x00000000,0x00000AE0,0x00000027,
  0x00000002,0x00000B20,0x00000003,0x00000B08,0x00000000,0x00000001,0x00000007,0x00000B08,
  0x00000174,0x00000001,0x00000000,0x00000B14,0x00000025,0x00000000,0x00000B20,0x00000027,
  0x00000002,0x00000B7C,0x00000003,0x00000B70,0x00000000,0x00000001,0x00000002,0x00000B70,
  0x00000007,0x00000B50,0x00000175,0x00000001,0x00000003,0x00000B70,0x00000000,0x00000001,
  0x00000007,0x00000B70,0x00000176,0x00000001,0x00000000,0x00000B7C,0x00000027,0x00000002,
  0x00000BDC,0x00000007,0x00000B94,0x00000177,0x00000001,0x00000003,0x00000BDC,0x00000000,
  0x00000001,0x00000002,0x00000BDC,0x00000007,0x00000BBC,0x00000178,0x00000001,0x00000003,
  0x00000BDC,0x00000000,0x00000001,0x00000007,0x00000BDC,0x00000179,0x00000001,0x00000005,
  0x00000BEC,0x00000030,0x00000039,0x00000001,0x00000C64,0x00000005,0x00000C04,0x00000030,
  0x00000039,0x00000007,0x00000C14,0x00000187,0x00000001,0x00000007,0x00000C24,0x00000188,
  0x00000001,0x00000007,0x00000C34,0x00000189,0x00000001,0x00000007,0x00000C44,0x0000018A,
  0x00000001,0x00000007,0x00000C54,0x0000018B,0x00000001,0x00000007,0x00000C64,0x0000018C,
  0x00000001,0x00000000,0x00000000,0x00000000,0x00000001,0x00000000,0x0000000C,0x00000000,
  0x00000020,0x00000000,0xFFFFFFFF,0x00000019,0x00000000,0x00000090,0x00000001,0x00000001,
  0x00000022,0x00000000,0x000000B0,0x00000001,0x00000002,0x0000002E,0x00000000,0x0000011C,
  0x00000001,0x00000003,0x00000035,0x00000000,0x0000014C,0x00000000,0xFFFFFFFF,0x0000003B,
  0x00000000,0x0000017C,0x00000001,0x00000004,0x00000044,0x00000000,0x000001AC,0x00000001,
  0x00000005,0x0000004D,0x00000000,0x000001E8,0x00000001,0x00000006,0x00000056,0x00000000,
  0x00000234,0x00000001,0x00000007,0x0000005F,0x00000000,0x00000270,0x00000000,0xFFFFFFFF,
  0x00000065,0x00000000,0x0000028C,0x00000000,0xFFFFFFFF,0x0000006E,0x00000000,0x000002AC,
  0x00000001,0x00000008,0x0000007A,0x00000000,0x00000330,0x00000001,0x00000009,0x00000081,
  0x00000000,0x00000384,0x00000000,0xFFFFFFFF,0x00000087,0x00000000,0x000003B4,0x00000001,
  0x0000000A,0x00000090,0x00000000,0x000003F0,0x00000001,0x0000000B,0x00000099,0x00000000,
  0x00000438,0x00000001,0x0000000C,0x000000A2,0x00000000,0x00000490,0x00000001,0x0000000D,
  0x000000AB,0x00000000,0x000004E8,0x00000001,0x0000000E,0x000000B4,0x00000000,0x00000540,
  0x00000001,0x0000000F,0x000000BD,0x00000000,0x0000057C,0x00000000,0xFFFFFFFF,0x000000C3,
  0x00000000,0x000005AC,0x00000000,0xFFFFFFFF,0x000000D2,0x00000000,0x0000061C,0x00000000,
  0xFFFFFFFF,0x000000DC,0x00000000,0x0000063C,0x00000000,0xFFFFFFFF,0x000000E9,0x00000000,
  0x00000694,0x00000000,0xFFFFFFFF,0x000000F1,0x00000000,0x000006D4,0x00000000,0xFFFFFFFF,
  0x000000FB,0x00000000,0x000006F4,0x00000000,0xFFFFFFFF,0x00000108,0x00000000,0x00000764,
  0x00000000,0xFFFFFFFF,0x00000110,0x00000000,0x000007B0,0x00000000,0xFFFFFFFF,0x0000011D,
  0x00000000,0x000007F8,0x00000000,0xFFFFFFFF,0x0000012A,0x00000000,0x000008B0,0x00000000,
  0xFFFFFFFF,0x0000012F,0x00000000,0x000008CC,0x00000000,0xFFFFFFFF,0x00000136,0x00000000,
  0x000008DC,0x00000001,0x00000010,0x0000013C,0x00000000,0x00000910,0x00000000,0xFFFFFFFF,
  0x00000142,0x00000000,0x00000944,0x00000001,0x00000011,0x0000014D,0x00000000,0x00000978,
  0x00000000,0xFFFFFFFF,0x00000154,0x00000000,0x00000988,0x00000000,0xFFFFFFFF,0x0000015E,
  0x00000000,0x00000998,0x00000000,0xFFFFFFFF,0x0000017A,0x00000000,0x00000BDC,0x00000000,
  0xFFFFFFFF,0x00000180,0x00000000,0x00000BEC,0x00000000,0xFFFFFFFF,
};

// UNIQUELY NAMED PARSER INITIALIZATION DATA
static APG_PARSER_INIT g_sParserInit = 
{
  0,
  (void*)g_pfnCallbacks,
  (void*)g_ulaExeData
};

void* vpIPv6LookAheadInit = (void*)&g_sParserInit;

// switch template
/*
  switch(ulState)
  {
  case SYN_PRE:
    break;
  case SYN_NOMATCH:
    break;
  case SYN_EMPTY:
    break;
  case SYN_MATCH:
    break;
  case SEM_PRE:
    break;
  case SEM_POST:
    break;
  }
*/

//{{CallBack.body
//////////////////////////////////////////////////////////////////////////
// DESCRIPTION: Count the number of colons in the string
//
// FUNCTION: static ulCountColons
//
//      ARG: 1) char* cpString
//              : pointer to the string
//
//      ARG: 2) ulong ulLen
//              : number of characters in the string
//
//   RETURN: the number of colons
//
//////////////////////////////////////////////////////////////////////////
static ulCountColons(char* cpString, ulong ulLen)
{
  ulong ulReturn = 0;
  ulong ulIndex = 0;
  --ulLen;
  for(; ulIndex < ulLen; ++ulIndex)
  {
    if(cpString[ulIndex] == ':')
    {
      if(cpString[ulIndex + 1] == ':')
      {
        break;
      }
      else
      {
        ++ulReturn;
      }
    }
  }

  return ulReturn;
}
//}}CallBack.body

// call back function for rule "IPv6Address"
static ulong pfn_IPv6Address(void* vpData, ulong ulState, ulong ulOffset, ulong ulLen)
{
  ulong ulReturn = PFN_OK;
//{{CallBack.pfn_IPv6Address
//}}CallBack.pfn_IPv6Address
  return ulReturn;
}

// call back function for rule "FormIPv4"
static ulong pfn_FormIPv4(void* vpData, ulong ulState, ulong ulOffset, ulong ulLen)
{
  ulong ulReturn = PFN_OK;
//{{CallBack.pfn_FormIPv4
  if(ulState == SYN_PRE)
  {
    APG_BSTR* spSrc = (APG_BSTR*)vpData;
    char* cpToken = (char*)spSrc->ucpStr + ulOffset;
    ulong ulIndex;
    ulong ulLength = spSrc->ulLen - ulOffset;
    
    // look ahead for period, fail this rule if not found
    ulReturn = PFN_SKIP;
    for(ulIndex = 0; ulIndex < ulLength; ++ulIndex)
    {
      if(cpToken[ulIndex] == '.')
      {
        ulReturn = PFN_OK;
        break;
      }
    }
  }
//}}CallBack.pfn_FormIPv4
  return ulReturn;
}

// call back function for rule "Compressed4"
static ulong pfn_Compressed4(void* vpData, ulong ulState, ulong ulOffset, ulong ulLen)
{
  ulong ulReturn = PFN_OK;
//{{CallBack.pfn_Compressed4
  if(ulState == SYN_PRE)
  {
    APG_BSTR* spSrc = (APG_BSTR*)vpData;
    char* cpToken = (char*)spSrc->ucpStr + ulOffset;
    ulong ulIndex;
    ulong ulLength = spSrc->ulLen - ulOffset;
    
    // look ahead for "::", fail this rule if not found
    ulReturn = PFN_SKIP;
    for(ulIndex = 1; ulIndex < ulLength; ++ulIndex)
    {
      if(cpToken[ulIndex - 1] == ':' && cpToken[ulIndex] == ':')
      {
        ulReturn = PFN_OK;
        break;
      }
    }
  }
//}}CallBack.pfn_Compressed4
  return ulReturn;
}

// call back function for rule "First4"
static ulong pfn_First4(void* vpData, ulong ulState, ulong ulOffset, ulong ulLen)
{
  ulong ulReturn = PFN_OK;
//{{CallBack.pfn_First4
  if(ulState == SYN_PRE)
  {
    APG_BSTR* spSrc = (APG_BSTR*)vpData;
    char* cpToken = (char*)spSrc->ucpStr + ulOffset;
    
    // look ahead for "::", fail this rule if not found
    ulReturn = PFN_SKIP;
    if(cpToken[0] == ':' && cpToken[1] == ':')
    {
      ulReturn = PFN_OK;
    }
  }
//}}CallBack.pfn_First4
  return ulReturn;
}

// call back function for rule "Middle41"
static ulong pfn_Middle41(void* vpData, ulong ulState, ulong ulOffset, ulong ulLen)
{
  ulong ulReturn = PFN_OK;
//{{CallBack.pfn_Middle41
  if(ulState == SYN_PRE)
  {
    APG_BSTR* spSrc = (APG_BSTR*)vpData;
    char* cpToken = (char*)spSrc->ucpStr + ulOffset;
    ulong ulCount;
    ulong ulLength = spSrc->ulLen - ulOffset;

    // fail this rule if incorrect number of colons found
    ulCount = ulCountColons(cpToken, ulLength);
    if(ulCount != 0)
    {
      ulReturn = PFN_SKIP;
    }
  }
//}}CallBack.pfn_Middle41
  return ulReturn;
}

// call back function for rule "Middle42"
static ulong pfn_Middle42(void* vpData, ulong ulState, ulong ulOffset, ulong ulLen)
{
  ulong ulReturn = PFN_OK;
//{{CallBack.pfn_Middle42
  if(ulState == SYN_PRE)
  {
    APG_BSTR* spSrc = (APG_BSTR*)vpData;
    char* cpToken = (char*)spSrc->ucpStr + ulOffset;
    ulong ulCount;
    ulong ulLength = spSrc->ulLen - ulOffset;
    
    // fail this rule if incorrect number of colons found
    ulCount = ulCountColons(cpToken, ulLength);
    if(ulCount != 1)
    {
      ulReturn = PFN_SKIP;
    }
  }
//}}CallBack.pfn_Middle42
  return ulReturn;
}

// call back function for rule "Middle43"
static ulong pfn_Middle43(void* vpData, ulong ulState, ulong ulOffset, ulong ulLen)
{
  ulong ulReturn = PFN_OK;
//{{CallBack.pfn_Middle43
  if(ulState == SYN_PRE)
  {
    APG_BSTR* spSrc = (APG_BSTR*)vpData;
    char* cpToken = (char*)spSrc->ucpStr + ulOffset;
    ulong ulCount;
    ulong ulLength = spSrc->ulLen - ulOffset;
    
    // fail this rule if incorrect number of colons found
    ulCount = ulCountColons(cpToken, ulLength);
    if(ulCount != 2)
    {
      ulReturn = PFN_SKIP;
    }
  }
//}}CallBack.pfn_Middle43
  return ulReturn;
}

// call back function for rule "Middle44"
static ulong pfn_Middle44(void* vpData, ulong ulState, ulong ulOffset, ulong ulLen)
{
  ulong ulReturn = PFN_OK;
//{{CallBack.pfn_Middle44
  if(ulState == SYN_PRE)
  {
    APG_BSTR* spSrc = (APG_BSTR*)vpData;
    char* cpToken = (char*)spSrc->ucpStr + ulOffset;
    ulong ulCount;
    ulong ulLength = spSrc->ulLen - ulOffset;
    
    // fail this rule if incorrect number of colons found
    ulCount = ulCountColons(cpToken, ulLength);
    if(ulCount != 3)
    {
      ulReturn = PFN_SKIP;
    }
  }
//}}CallBack.pfn_Middle44
  return ulReturn;
}

// call back function for rule "Compressed6"
static ulong pfn_Compressed6(void* vpData, ulong ulState, ulong ulOffset, ulong ulLen)
{
  ulong ulReturn = PFN_OK;
//{{CallBack.pfn_Compressed6
  if(ulState == SYN_PRE)
  {
    APG_BSTR* spSrc = (APG_BSTR*)vpData;
    char* cpToken = (char*)spSrc->ucpStr + ulOffset;
    ulong ulIndex;
    ulong ulLength = spSrc->ulLen - ulOffset;

    // fail this rule if "::" not found
    ulReturn = PFN_SKIP;
    for(ulIndex = 1; ulIndex < ulLength; ++ulIndex)
    {
      if(cpToken[ulIndex - 1] == ':' && cpToken[ulIndex] == ':')
      {
        ulReturn = PFN_OK;
        break;
      }
    }
  }
//}}CallBack.pfn_Compressed6
  return ulReturn;
}

// call back function for rule "First6"
static ulong pfn_First6(void* vpData, ulong ulState, ulong ulOffset, ulong ulLen)
{
  ulong ulReturn = PFN_OK;
//{{CallBack.pfn_First6
  if(ulState == SYN_PRE)
  {
    ulReturn = pfn_First4(vpData, ulState, ulOffset, ulLen);
  }
//}}CallBack.pfn_First6
  return ulReturn;
}

// call back function for rule "Middle61"
static ulong pfn_Middle61(void* vpData, ulong ulState, ulong ulOffset, ulong ulLen)
{
  ulong ulReturn = PFN_OK;
//{{CallBack.pfn_Middle61
  if(ulState == SYN_PRE)
  {
    APG_BSTR* spSrc = (APG_BSTR*)vpData;
    char* cpToken = (char*)spSrc->ucpStr + ulOffset;
    ulong ulCount;
    ulong ulLength = spSrc->ulLen - ulOffset;
    
    // fail this rule if incorrect number of colons found
    ulCount = ulCountColons(cpToken, ulLength);
    if(ulCount != 0)
    {
      ulReturn = PFN_SKIP;
    }
  }
//}}CallBack.pfn_Middle61
  return ulReturn;
}

// call back function for rule "Middle62"
static ulong pfn_Middle62(void* vpData, ulong ulState, ulong ulOffset, ulong ulLen)
{
  ulong ulReturn = PFN_OK;
//{{CallBack.pfn_Middle62
  if(ulState == SYN_PRE)
  {
    APG_BSTR* spSrc = (APG_BSTR*)vpData;
    char* cpToken = (char*)spSrc->ucpStr + ulOffset;
    ulong ulCount;
    ulong ulLength = spSrc->ulLen - ulOffset;
    
    // fail this rule if incorrect number of colons found
    ulCount = ulCountColons(cpToken, ulLength);
    if(ulCount != 1)
    {
      ulReturn = PFN_SKIP;
    }
  }
//}}CallBack.pfn_Middle62
  return ulReturn;
}

// call back function for rule "Middle63"
static ulong pfn_Middle63(void* vpData, ulong ulState, ulong ulOffset, ulong ulLen)
{
  ulong ulReturn = PFN_OK;
//{{CallBack.pfn_Middle63
  if(ulState == SYN_PRE)
  {
    APG_BSTR* spSrc = (APG_BSTR*)vpData;
    char* cpToken = (char*)spSrc->ucpStr + ulOffset;
    ulong ulCount;
    ulong ulLength = spSrc->ulLen - ulOffset;
    
    // fail this rule if incorrect number of colons found
    ulCount = ulCountColons(cpToken, ulLength);
    if(ulCount != 2)
    {
      ulReturn = PFN_SKIP;
    }
  }
//}}CallBack.pfn_Middle63
  return ulReturn;
}

// call back function for rule "Middle64"
static ulong pfn_Middle64(void* vpData, ulong ulState, ulong ulOffset, ulong ulLen)
{
  ulong ulReturn = PFN_OK;
//{{CallBack.pfn_Middle64
  if(ulState == SYN_PRE)
  {
    APG_BSTR* spSrc = (APG_BSTR*)vpData;
    char* cpToken = (char*)spSrc->ucpStr + ulOffset;
    ulong ulCount;
    ulong ulLength = spSrc->ulLen - ulOffset;
    
    // fail this rule if incorrect number of colons found
    ulCount = ulCountColons(cpToken, ulLength);
    if(ulCount != 3)
    {
      ulReturn = PFN_SKIP;
    }
  }
//}}CallBack.pfn_Middle64
  return ulReturn;
}

// call back function for rule "Middle65"
static ulong pfn_Middle65(void* vpData, ulong ulState, ulong ulOffset, ulong ulLen)
{
  ulong ulReturn = PFN_OK;
//{{CallBack.pfn_Middle65
  if(ulState == SYN_PRE)
  {
    APG_BSTR* spSrc = (APG_BSTR*)vpData;
    char* cpToken = (char*)spSrc->ucpStr + ulOffset;
    ulong ulCount;
    ulong ulLength = spSrc->ulLen - ulOffset;
    
    // fail this rule if incorrect number of colons found
    ulCount = ulCountColons(cpToken, ulLength);
    if(ulCount != 4)
    {
      ulReturn = PFN_SKIP;
    }
  }
//}}CallBack.pfn_Middle65
  return ulReturn;
}

// call back function for rule "Middle66"
static ulong pfn_Middle66(void* vpData, ulong ulState, ulong ulOffset, ulong ulLen)
{
  ulong ulReturn = PFN_OK;
//{{CallBack.pfn_Middle66
  if(ulState == SYN_PRE)
  {
    APG_BSTR* spSrc = (APG_BSTR*)vpData;
    char* cpToken = (char*)spSrc->ucpStr + ulOffset;
    ulong ulCount;
    ulong ulLength = spSrc->ulLen - ulOffset;
    
    // fail this rule if incorrect number of colons found
    ulCount = ulCountColons(cpToken, ulLength);
    if(ulCount != 5)
    {
      ulReturn = PFN_SKIP;
    }
  }
//}}CallBack.pfn_Middle66
  return ulReturn;
}

// call back function for rule "HEXC"
static ulong pfn_HEXC(void* vpData, ulong ulState, ulong ulOffset, ulong ulLen)
{
  ulong ulReturn = PFN_OK;
//{{CallBack.pfn_HEXC
  if(ulState == SYN_PRE)
  {
    APG_BSTR* spSrc = (APG_BSTR*)vpData;
    char* cpToken = (char*)spSrc->ucpStr + ulOffset;
    ulong ulIndex = 0;

    // fail this rule if period found before colon
    for(; ulIndex < ulLen; ++ulIndex)
    {
      if(cpToken[ulIndex] == '.')
      {
        ulReturn = PFN_SKIP;
        break;
      }

      if(cpToken[ulIndex] == ':')
      {
        break;
      }
    }
  }
//}}CallBack.pfn_HEXC
  return ulReturn;
}

// call back function for rule "MULTIDIG"
static ulong pfn_MULTIDIG(void* vpData, ulong ulState, ulong ulOffset, ulong ulLen)
{
  ulong ulReturn = PFN_OK;
//{{CallBack.pfn_MULTIDIG
  if(ulState == SYN_PRE)
  {
    APG_BSTR* spSrc = (APG_BSTR*)vpData;
    char* cpToken = (char*)spSrc->ucpStr + ulOffset;
    ulong ulFirst, ulSecond;
    ulong ulLength = spSrc->ulLen - ulOffset;
    
    // fail this rule if "FF" not first two characters
    ulFirst = (ulong)(cpToken[0] == 'F' || cpToken[0] == 'f');
    ulSecond = (ulong)(cpToken[1] == 'F' || cpToken[1] == 'f');
    if(!(ulFirst && ulSecond))
    {
      ulReturn = PFN_SKIP;
    }
  }
//}}CallBack.pfn_MULTIDIG
  return ulReturn;
}

