/********************************************************************
  APG - an ABNF Parser Generator
  Copyright  (C) 2007 Coast to Coast Research, Inc.
 
  This program is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 2 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program.  If not, see
  <http://www.gnu.org/licenses/old-licenses/gpl-2.0.html>
  or write to the Free Software Foundation, Inc.,
  51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
  
	 created: Wed Nov 21 08:45:41 2007
	filename: MEGACO.h
	  author: Lowell Thomas
	          lowell@coasttocoastresearch.com
	          http://www.coasttocoastresearch.com

	 purpose: Header file for parser MEGACO.

*********************************************************************/
#ifndef MEGACO_h
#define MEGACO_h

//{{header.pre
//}}header.pre

// rule name IDs
#define RULE_MEGACO_MEGACOMESSAGE 0
#define RULE_MEGACO_AUTHENTICATIONHEADER 1
#define RULE_MEGACO_SECURITYPARMINDEX 2
#define RULE_MEGACO_SEQUENCENUM 3
#define RULE_MEGACO_AUTHDATA 4
#define RULE_MEGACO_MESSAGE 5
#define RULE_MEGACO_MESSAGEBODY 6
#define RULE_MEGACO_TRANSACTIONLIST 7
#define RULE_MEGACO_TRANSACTIONREQUEST 8
#define RULE_MEGACO_TRANSACTIONREPLY 9
#define RULE_MEGACO_TRANSACTIONPENDING 10
#define RULE_MEGACO_TRANSACTIONRESPONSEACK 11
#define RULE_MEGACO_SEGMENTREPLY 12
#define RULE_MEGACO_TRANSACTIONACK 13
#define RULE_MEGACO_ACTIONREQUEST 14
#define RULE_MEGACO_CONTEXTREQUEST 15
#define RULE_MEGACO_CONTEXTPROPERTIES 16
#define RULE_MEGACO_CONTEXTPROPERTY 17
#define RULE_MEGACO_CONTEXTAUDIT 18
#define RULE_MEGACO_CONTEXTAUDITPROPERTIES 19
#define RULE_MEGACO_CONTEXTAUDITSELECTOR 20
#define RULE_MEGACO_AUDITSELECTLOGIC 21
#define RULE_MEGACO_INDAUDCONTEXTATTRDESCRIPTOR 22
#define RULE_MEGACO_COMMANDREQUESTLIST 23
#define RULE_MEGACO_COMMANDREQUEST 24
#define RULE_MEGACO_SEGMENTNUMBER 25
#define RULE_MEGACO_ACTIONREPLYLIST 26
#define RULE_MEGACO_ACTIONREPLY 27
#define RULE_MEGACO_COMMANDREPLY 28
#define RULE_MEGACO_COMMANDREPLYLIST 29
#define RULE_MEGACO_COMMANDREPLYS 30
#define RULE_MEGACO_AMMREQUEST 31
#define RULE_MEGACO_AMMPARAMETER 32
#define RULE_MEGACO_AMMSREPLY 33
#define RULE_MEGACO_SUBTRACTREQUEST 34
#define RULE_MEGACO_AUDITREQUEST 35
#define RULE_MEGACO_AUDITREPLY 36
#define RULE_MEGACO_AUDITOTHER 37
#define RULE_MEGACO_TERMINATIONAUDIT 38
#define RULE_MEGACO_CONTEXTTERMINATIONAUDIT 39
#define RULE_MEGACO_AUDITRETURNPARAMETER 40
#define RULE_MEGACO_AUDITRETURNITEM 41
#define RULE_MEGACO_AUDITDESCRIPTOR 42
#define RULE_MEGACO_NOTIFYREQUEST 43
#define RULE_MEGACO_NOTIFYREPLY 44
#define RULE_MEGACO_SERVICECHANGEREQUEST 45
#define RULE_MEGACO_SERVICECHANGEREPLY 46
#define RULE_MEGACO_ERRORDESCRIPTOR 47
#define RULE_MEGACO_ERRORCODE 48
#define RULE_MEGACO_TRANSACTIONID 49
#define RULE_MEGACO_MID 50
#define RULE_MEGACO_DOMAINNAME 51
#define RULE_MEGACO_DEVICENAME 52
#define RULE_MEGACO_CONTEXTID 53
#define RULE_MEGACO_DOMAINADDRESS 54
#define RULE_MEGACO_IPV6ADDRESS 55
#define RULE_MEGACO_IPV4ADDRESS 56
#define RULE_MEGACO_V4HEX 57
#define RULE_MEGACO_HEXPART 58
#define RULE_MEGACO_HEXSEQ 59
#define RULE_MEGACO_HEX4 60
#define RULE_MEGACO_PORTNUMBER 61
#define RULE_MEGACO_MTPADDRESS 62
#define RULE_MEGACO_TERMIDLIST 63
#define RULE_MEGACO_TERMINATIONIDLIST 64
#define RULE_MEGACO_PATHNAME 65
#define RULE_MEGACO_PATHDOMAINNAME 66
#define RULE_MEGACO_TERMINATIONID 67
#define RULE_MEGACO_MEDIADESCRIPTOR 68
#define RULE_MEGACO_MEDIAPARM 69
#define RULE_MEGACO_STREAMPARM 70
#define RULE_MEGACO_STREAMDESCRIPTOR 71
#define RULE_MEGACO_LOCALCONTROLDESCRIPTOR 72
#define RULE_MEGACO_LOCALPARM 73
#define RULE_MEGACO_RESERVEDVALUEMODE 74
#define RULE_MEGACO_RESERVEDGROUPMODE 75
#define RULE_MEGACO_STREAMMODE 76
#define RULE_MEGACO_STREAMMODES 77
#define RULE_MEGACO_PROPERTYPARM 78
#define RULE_MEGACO_PARMVALUE 79
#define RULE_MEGACO_ALTERNATIVEVALUE 80
#define RULE_MEGACO_INEQUAL 81
#define RULE_MEGACO_LSBRKT 82
#define RULE_MEGACO_RSBRKT 83
#define RULE_MEGACO_LOCALDESCRIPTOR 84
#define RULE_MEGACO_REMOTEDESCRIPTOR 85
#define RULE_MEGACO_EVENTBUFFERDESCRIPTOR 86
#define RULE_MEGACO_EVENTSPEC 87
#define RULE_MEGACO_EVENTSPECPARAMETER 88
#define RULE_MEGACO_EVENTBUFFERCONTROL 89
#define RULE_MEGACO_EVENTBUFFERCONTROLVALUE 90
#define RULE_MEGACO_TERMINATIONSTATEDESCRIPTOR 91
#define RULE_MEGACO_TERMINATIONSTATEPARM 92
#define RULE_MEGACO_SERVICESTATES 93
#define RULE_MEGACO_SERVICESTATESVALUE 94
#define RULE_MEGACO_MUXDESCRIPTOR 95
#define RULE_MEGACO_MUXTYPE 96
#define RULE_MEGACO_STREAMID 97
#define RULE_MEGACO_PKGDNAME 98
#define RULE_MEGACO_PACKAGENAME 99
#define RULE_MEGACO_ITEMID 100
#define RULE_MEGACO_EVENTSDESCRIPTOR 101
#define RULE_MEGACO_REQUESTEDEVENT 102
#define RULE_MEGACO_NOTIFYREGULATED 103
#define RULE_MEGACO_NOTIFYBEHAVIOUR 104
#define RULE_MEGACO_EVENTPARAMETER 105
#define RULE_MEGACO_EMBEDWITHSIG 106
#define RULE_MEGACO_EMBEDNOSIG 107
#define RULE_MEGACO_EMBEDFIRST 108
#define RULE_MEGACO_SECONDREQUESTEDEVENT 109
#define RULE_MEGACO_SECONDEVENTPARAMETER 110
#define RULE_MEGACO_EMBEDSIG 111
#define RULE_MEGACO_EVENTSTREAM 112
#define RULE_MEGACO_EVENTOTHER 113
#define RULE_MEGACO_EVENTPARAMETERNAME 114
#define RULE_MEGACO_EVENTDM 115
#define RULE_MEGACO_SIGNALSDESCRIPTOR 116
#define RULE_MEGACO_SIGNALPARM 117
#define RULE_MEGACO_SIGNALREQUEST 118
#define RULE_MEGACO_SIGNALLIST 119
#define RULE_MEGACO_SIGNALLISTID 120
#define RULE_MEGACO_SIGNALLISTPARM 121
#define RULE_MEGACO_SIGNALNAME 122
#define RULE_MEGACO_SIGPARAMETER 123
#define RULE_MEGACO_SIGSTREAM 124
#define RULE_MEGACO_SIGOTHER 125
#define RULE_MEGACO_SIGPARAMETERNAME 126
#define RULE_MEGACO_SIGSIGNALTYPE 127
#define RULE_MEGACO_SIGNALTYPE 128
#define RULE_MEGACO_SIGDURATION 129
#define RULE_MEGACO_SIGDIRECTION 130
#define RULE_MEGACO_DIRECTION 131
#define RULE_MEGACO_SIGREQUESTID 132
#define RULE_MEGACO_SIGINTSIGDELAY 133
#define RULE_MEGACO_NOTIFYCOMPLETION 134
#define RULE_MEGACO_NOTIFICATIONREASON 135
#define RULE_MEGACO_OBSERVEDEVENTSDESCRIPTOR 136
#define RULE_MEGACO_OBSERVEDEVENT 137
#define RULE_MEGACO_OBSERVEDEVENTPARAMETER 138
#define RULE_MEGACO_REQUESTID 139
#define RULE_MEGACO_MODEMDESCRIPTOR 140
#define RULE_MEGACO_MODEMTYPE 141
#define RULE_MEGACO_DIGITMAPDESCRIPTOR 142
#define RULE_MEGACO_DIGITMAPNAME 143
#define RULE_MEGACO_DIGITMAPVALUE 144
#define RULE_MEGACO_TIMER 145
#define RULE_MEGACO_DIGITMAP 146
#define RULE_MEGACO_DIGITSTRINGLIST 147
#define RULE_MEGACO_DIGITSTRING 148
#define RULE_MEGACO_DIGITSTRINGELEMENT 149
#define RULE_MEGACO_DIGITPOSITION 150
#define RULE_MEGACO_DIGITMAPRANGE 151
#define RULE_MEGACO_DIGITLETTER 152
#define RULE_MEGACO_DIGITMAPLETTER 153
#define RULE_MEGACO_AUDITITEM 154
#define RULE_MEGACO_INDAUDTERMINATIONAUDIT 155
#define RULE_MEGACO_INDAUDAUDITRETURNPARAMETER 156
#define RULE_MEGACO_INDAUDMEDIADESCRIPTOR 157
#define RULE_MEGACO_INDAUDMEDIAPARM 158
#define RULE_MEGACO_INDAUDSTREAMPARM 159
#define RULE_MEGACO_INDAUDREMOTEDESCRIPTOR 160
#define RULE_MEGACO_INDAUDLOCALDESCRIPTOR 161
#define RULE_MEGACO_INDAUDSTREAMDESCRIPTOR 162
#define RULE_MEGACO_INDAUDLOCALCONTROLDESCRIPTOR 163
#define RULE_MEGACO_INDAUDLOCALPARM 164
#define RULE_MEGACO_INDAUDTERMINATIONSTATEDESCRIPTOR 165
#define RULE_MEGACO_INDAUDTERMINATIONSTATEPARM 166
#define RULE_MEGACO_INDAUDEVENTBUFFERDESCRIPTOR 167
#define RULE_MEGACO_INDAUDEVENTSPEC 168
#define RULE_MEGACO_INDAUDEVENTSPECPARAMETER 169
#define RULE_MEGACO_INDAUDEVENTSDESCRIPTOR 170
#define RULE_MEGACO_INDAUDREQUESTEDEVENT 171
#define RULE_MEGACO_INDAUDSIGNALSDESCRIPTOR 172
#define RULE_MEGACO_INDAUDSIGNALPARM 173
#define RULE_MEGACO_INDAUDSIGNALREQUEST 174
#define RULE_MEGACO_INDAUDSIGNALREQUESTPARM 175
#define RULE_MEGACO_INDAUDSIGNALLIST 176
#define RULE_MEGACO_INDAUDSIGNALLISTPARM 177
#define RULE_MEGACO_INDAUDDIGITMAPDESCRIPTOR 178
#define RULE_MEGACO_INDAUDSTATISTICSDESCRIPTOR 179
#define RULE_MEGACO_INDAUDPACKAGESDESCRIPTOR 180
#define RULE_MEGACO_SERVICECHANGEDESCRIPTOR 181
#define RULE_MEGACO_SERVICECHANGEPARM 182
#define RULE_MEGACO_SERVICECHANGEREPLYDESCRIPTOR 183
#define RULE_MEGACO_SERVCHGREPLYPARM 184
#define RULE_MEGACO_SERVICECHANGEMETHOD 185
#define RULE_MEGACO_SERVICECHANGEREASON 186
#define RULE_MEGACO_SERVICECHANGEDELAY 187
#define RULE_MEGACO_SERVICECHANGEADDRESS 188
#define RULE_MEGACO_SERVICECHANGEMGCID 189
#define RULE_MEGACO_SERVICECHANGEPROFILE 190
#define RULE_MEGACO_SERVICECHANGEVERSION 191
#define RULE_MEGACO_EXTENSION 192
#define RULE_MEGACO_PACKAGESDESCRIPTOR 193
#define RULE_MEGACO_VERSION 194
#define RULE_MEGACO_PACKAGESITEM 195
#define RULE_MEGACO_TIMESTAMP 196
#define RULE_MEGACO_DATE 197
#define RULE_MEGACO_TIME 198
#define RULE_MEGACO_STATISTICSDESCRIPTOR 199
#define RULE_MEGACO_STATISTICSPARAMETER 200
#define RULE_MEGACO_TOPOLOGYDESCRIPTOR 201
#define RULE_MEGACO_TOPOLOGYTRIPLE 202
#define RULE_MEGACO_TERMINATIONA 203
#define RULE_MEGACO_TERMINATIONB 204
#define RULE_MEGACO_TOPOLOGYDIRECTION 205
#define RULE_MEGACO_PRIORITY 206
#define RULE_MEGACO_IEPSVALUE 207
#define RULE_MEGACO_EMERGENCYVALUE 208
#define RULE_MEGACO_CONTEXTATTRDESCRIPTOR 209
#define RULE_MEGACO_CONTEXTIDLIST 210
#define RULE_MEGACO_EXTENSIONPARAMETER 211
#define RULE_MEGACO_OCTETSTRING 212
#define RULE_MEGACO_NONESCAPECHAR 213
#define RULE_MEGACO_QUOTEDSTRING 214
#define RULE_MEGACO_UINT16 215
#define RULE_MEGACO_UINT32 216
#define RULE_MEGACO_NAME 217
#define RULE_MEGACO_VALUE 218
#define RULE_MEGACO_SAFECHAR 219
#define RULE_MEGACO_EQUAL 220
#define RULE_MEGACO_COLON 221
#define RULE_MEGACO_LBRKT 222
#define RULE_MEGACO_RBRKT 223
#define RULE_MEGACO_COMMA 224
#define RULE_MEGACO_DOT 225
#define RULE_MEGACO_SLASH 226
#define RULE_MEGACO_ALPHA 227
#define RULE_MEGACO_DIGIT 228
#define RULE_MEGACO_DQUOTE 229
#define RULE_MEGACO_HEXDIG 230
#define RULE_MEGACO_SP 231
#define RULE_MEGACO_HTAB 232
#define RULE_MEGACO_CR 233
#define RULE_MEGACO_LF 234
#define RULE_MEGACO_LWSP 235
#define RULE_MEGACO_EOL 236
#define RULE_MEGACO_WSP 237
#define RULE_MEGACO_SEP 238
#define RULE_MEGACO_COMMENT 239
#define RULE_MEGACO_RESTCHAR 240
#define RULE_MEGACO_ADDTOKEN 241
#define RULE_MEGACO_ANDAUDITSELECTTOKEN 242
#define RULE_MEGACO_AUDITTOKEN 243
#define RULE_MEGACO_AUDITCAPTOKEN 244
#define RULE_MEGACO_AUDITVALUETOKEN 245
#define RULE_MEGACO_AUTHTOKEN 246
#define RULE_MEGACO_BOTHTOKEN 247
#define RULE_MEGACO_BOTHWAYTOKEN 248
#define RULE_MEGACO_BRIEFTOKEN 249
#define RULE_MEGACO_BUFFERTOKEN 250
#define RULE_MEGACO_CTXTOKEN 251
#define RULE_MEGACO_CONTEXTAUDITTOKEN 252
#define RULE_MEGACO_CONTEXTATTRTOKEN 253
#define RULE_MEGACO_CONTEXTLISTTOKEN 254
#define RULE_MEGACO_DIGITMAPTOKEN 255
#define RULE_MEGACO_DIRECTIONTOKEN 256
#define RULE_MEGACO_DISCONNECTEDTOKEN 257
#define RULE_MEGACO_DELAYTOKEN 258
#define RULE_MEGACO_DURATIONTOKEN 259
#define RULE_MEGACO_EMBEDTOKEN 260
#define RULE_MEGACO_EMERGENCYTOKEN 261
#define RULE_MEGACO_EMERGENCYOFFTOKEN 262
#define RULE_MEGACO_EMERGENCYVALUETOKEN 263
#define RULE_MEGACO_ERRORTOKEN 264
#define RULE_MEGACO_EVENTBUFFERTOKEN 265
#define RULE_MEGACO_EVENTSTOKEN 266
#define RULE_MEGACO_EXTERNALTOKEN 267
#define RULE_MEGACO_FAILOVERTOKEN 268
#define RULE_MEGACO_FORCEDTOKEN 269
#define RULE_MEGACO_GRACEFULTOKEN 270
#define RULE_MEGACO_H221TOKEN 271
#define RULE_MEGACO_H223TOKEN 272
#define RULE_MEGACO_H226TOKEN 273
#define RULE_MEGACO_HANDOFFTOKEN 274
#define RULE_MEGACO_IEPSTOKEN 275
#define RULE_MEGACO_IMMACKREQUIREDTOKEN 276
#define RULE_MEGACO_INACTIVETOKEN 277
#define RULE_MEGACO_INTERNALTOKEN 278
#define RULE_MEGACO_INTSIGDELAYTOKEN 279
#define RULE_MEGACO_ISOLATETOKEN 280
#define RULE_MEGACO_INSVCTOKEN 281
#define RULE_MEGACO_INTERRUPTBYEVENTTOKEN 282
#define RULE_MEGACO_INTERRUPTBYNEWSIGNALSDESCRTOKEN 283
#define RULE_MEGACO_ITERATIONTOKEN 284
#define RULE_MEGACO_KEEPACTIVETOKEN 285
#define RULE_MEGACO_LOCALTOKEN 286
#define RULE_MEGACO_LOCALCONTROLTOKEN 287
#define RULE_MEGACO_LOCKSTEPTOKEN 288
#define RULE_MEGACO_LOOPBACKTOKEN 289
#define RULE_MEGACO_MEDIATOKEN 290
#define RULE_MEGACO_MEGACOPTOKEN 291
#define RULE_MEGACO_MESSAGESEGMENTTOKEN 292
#define RULE_MEGACO_METHODTOKEN 293
#define RULE_MEGACO_MGCIDTOKEN 294
#define RULE_MEGACO_MODETOKEN 295
#define RULE_MEGACO_MODIFYTOKEN 296
#define RULE_MEGACO_MODEMTOKEN 297
#define RULE_MEGACO_MOVETOKEN 298
#define RULE_MEGACO_MTPTOKEN 299
#define RULE_MEGACO_MUXTOKEN 300
#define RULE_MEGACO_NEVERNOTIFYTOKEN 301
#define RULE_MEGACO_NOTIFYTOKEN 302
#define RULE_MEGACO_NOTIFYCOMPLETIONTOKEN 303
#define RULE_MEGACO_NOTIFYIMMEDIATETOKEN 304
#define RULE_MEGACO_NOTIFYREGULATEDTOKEN 305
#define RULE_MEGACO_NX64KTOKEN 306
#define RULE_MEGACO_OBSERVEDEVENTSTOKEN 307
#define RULE_MEGACO_ONEWAYTOKEN 308
#define RULE_MEGACO_ONEWAYBOTHTOKEN 309
#define RULE_MEGACO_ONEWAYEXTERNALTOKEN 310
#define RULE_MEGACO_ONOFFTOKEN 311
#define RULE_MEGACO_ORAUDITSELECTTOKEN 312
#define RULE_MEGACO_OTHERREASONTOKEN 313
#define RULE_MEGACO_OUTOFSVCTOKEN 314
#define RULE_MEGACO_PACKAGESTOKEN 315
#define RULE_MEGACO_PENDINGTOKEN 316
#define RULE_MEGACO_PRIORITYTOKEN 317
#define RULE_MEGACO_PROFILETOKEN 318
#define RULE_MEGACO_REASONTOKEN 319
#define RULE_MEGACO_RECVONLYTOKEN 320
#define RULE_MEGACO_REPLYTOKEN 321
#define RULE_MEGACO_RESETEVENTSDESCRIPTORTOKEN 322
#define RULE_MEGACO_RESTARTTOKEN 323
#define RULE_MEGACO_REMOTETOKEN 324
#define RULE_MEGACO_REQUESTIDTOKEN 325
#define RULE_MEGACO_RESERVEDGROUPTOKEN 326
#define RULE_MEGACO_RESERVEDVALUETOKEN 327
#define RULE_MEGACO_SEGMENTATIONCOMPLETETOKEN 328
#define RULE_MEGACO_SENDONLYTOKEN 329
#define RULE_MEGACO_SENDRECVTOKEN 330
#define RULE_MEGACO_SERVICESTOKEN 331
#define RULE_MEGACO_SERVICESTATESTOKEN 332
#define RULE_MEGACO_SERVICECHANGEINCOMPLETETOKEN 333
#define RULE_MEGACO_SERVICECHANGETOKEN 334
#define RULE_MEGACO_SERVICECHANGEADDRESSTOKEN 335
#define RULE_MEGACO_SIGNALLISTTOKEN 336
#define RULE_MEGACO_SIGNALSTOKEN 337
#define RULE_MEGACO_SIGNALTYPETOKEN 338
#define RULE_MEGACO_STATSTOKEN 339
#define RULE_MEGACO_STREAMTOKEN 340
#define RULE_MEGACO_SUBTRACTTOKEN 341
#define RULE_MEGACO_SYNCHISDNTOKEN 342
#define RULE_MEGACO_TERMINATIONSTATETOKEN 343
#define RULE_MEGACO_TESTTOKEN 344
#define RULE_MEGACO_TIMEOUTTOKEN 345
#define RULE_MEGACO_TOPOLOGYTOKEN 346
#define RULE_MEGACO_TRANSTOKEN 347
#define RULE_MEGACO_RESPONSEACKTOKEN 348
#define RULE_MEGACO_V18TOKEN 349
#define RULE_MEGACO_V22TOKEN 350
#define RULE_MEGACO_V22BISTOKEN 351
#define RULE_MEGACO_V32TOKEN 352
#define RULE_MEGACO_V32BISTOKEN 353
#define RULE_MEGACO_V34TOKEN 354
#define RULE_MEGACO_V76TOKEN 355
#define RULE_MEGACO_V90TOKEN 356
#define RULE_MEGACO_V91TOKEN 357
#define RULE_MEGACO_VERSIONTOKEN 358

extern void* vpMEGACOInit;

//{{header.post
//}}header.post

#endif // MEGACO_h
