/********************************************************************
  APG - an ABNF Parser Generator
  Copyright  (C) 2007 Coast to Coast Research, Inc.
 
  This program is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 2 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program.  If not, see
  <http://www.gnu.org/licenses/old-licenses/gpl-2.0.html>
  or write to the Free Software Foundation, Inc.,
  51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

    author: Lowell Thomas
            lowell@coasttocoastresearch.com
            http://www.coasttocoastresearch.com

   created: 8/26/2007 11:34
  filename: D:\Projects\Apgv5_0\Samples\NonContextFree\main.c
   purpose: Driver program for testing a couple simple examples
            of non-context-free grammars.
  
*********************************************************************/
#include "main.h"

//////////////////////////////////////////////////////////////////////////
// DESCRIPTION: Driver program
//
// FUNCTION: int main
//
//      ARG: 1) int argc
//              : number of command line arguments
//
//      ARG: 2) char** argv
//              : pointer to a list of pointers to the command line arguments
//
//   RETURN: 
//
//////////////////////////////////////////////////////////////////////////
int main(int argc, char** argv)
{
  PFN_ALERT pfnOldAlertHandler;
  void* vpMemCtx;

  // set the custom alert handler
  pfnOldAlertHandler = pfnSetAlertHandler(vTerminalAlert);
  
  // print copyright notice to console
  vLicenseNotice();
  // redirect output
  {
    FILE* spRedirectOut;
    printf("%s - output redirect file\n", "main.log");
    spRedirectOut = freopen("main.log", "w", stdout);
    MAINASSERT(spRedirectOut);

    // print copyright notice to the output file
    vLicenseNotice();
  }

  vpMemCtx = vpMemCtor();
  MAINASSERT(vpMemCtx);

  vTestAnBnCn(vpMemCtx);

  vPrintMemStats(vpMemCtx);
  vMemDtor(vpMemCtx);

  return 0;
}
