/********************************************************************
  APG - an ABNF Parser Generator
  Copyright  (C) 2007 Coast to Coast Research, Inc.
 
  This program is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 2 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program.  If not, see
  <http://www.gnu.org/licenses/old-licenses/gpl-2.0.html>
  or write to the Free Software Foundation, Inc.,
  51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

    author: Lowell Thomas
            lowell@coasttocoastresearch.com
            http://www.coasttocoastresearch.com

   created: 8/27/2007 10:12
  filename: D:\Projects\Apgv5_0\Samples\SDP\SDPLines.h
  purpose: Header information for SDPLines.c and the applications
                using it.
  
*********************************************************************/
#ifndef SDPLines_h_6_30_2007
#define SDPLines_h_6_30_2007

// line identifiers
enum
{
  SESSION_VERSION = 0,
  SESSION_ORIGIN,
  SESSION_NAME,
  SESSION_INFORMATION,
  SESSION_URI,
  SESSION_EMAIL,
  SESSION_PHONE,
  SESSION_CONNECTION,
  SESSION_BANDWIDTH,
  SESSION_TIME,
  SESSION_REPEAT,
  SESSION_ZONE,
  SESSION_KEY,
  SESSION_ATTRIBUTE,
  MEDIA_MEDIA,
  MEDIA_INFORMATION,
  MEDIA_CONNECTION,
  MEDIA_BANDWIDTH,
  MEDIA_KEY,
  MEDIA_ATTRIBUTE,
  SESSION_COUNT
} SDP_ANNOUNCEMENT;

// translates line identifiers
typedef struct
{
  ulong ulID;
  char* cpLinePrefix;
  char* cpLineName;
} LINE_NAME;

typedef struct
{
  APG_BSTR* spAnnouncement;
  APG_BSTR  sNextLine;
  ulong     ulMode;
} LINE_ITERATOR;

extern LINE_NAME* spLinesTranslator;
ulong ulLinesInit(LINE_ITERATOR* spIter, APG_BSTR* spAnnouncement);
ulong ulLinesNext(LINE_ITERATOR* spIter, APG_BSTR* spLine, ulong* ulID);

#endif /* SDPLines_h_6_30_2007 */
