# common make file for the APG library
#
.SUFFIXES:
.SUFFIXES: .c .cpp .o
#
SHELL  = /bin/sh
SRCDIR = .
PUBDIR = ../../public
OBJDIR = $(SRCDIR)/$(OBJNAME)
DEPEND = $(SRCDIR)/main.h $(PUBDIR)/*.a
CFLAGS = -I$(PUBDIR)
LFLAGS = -L$(PUBDIR)
EXE    = $(EXENAME)
OBJS   = $(OBJDIR)/main.o \
         $(OBJDIR)/Headers.o \
         $(OBJDIR)/Messages.o \
         $(OBJDIR)/PreParser.o \
         $(OBJDIR)/SIP.o \
         $(OBJDIR)/SIPPPT.o \
         $(OBJDIR)/SIPPPTLazy.o \
         $(OBJDIR)/Timing.o \
         $(OBJDIR)/TortureTests.o \
         $(OBJDIR)/Utilities.o
#
# build all
all : $(OBJDIR) $(OBJS) $(EXENAME)
#
# create the directories, if neccessary
$(OBJDIR) :
	mkdir $(OBJDIR)
	chmod 755 $(OBJDIR)
#
$(EXE) : $(OBJS)
	$(CC) -o $(EXE) $(OBJS) $(LFLAGS) -l$(LIBNAME) -l$(UTILNAME)
#
# implicit rules
$(OBJDIR)/%.o: $(SRCDIR)/%.c $(DEPEND)
	$(CC) -c $(CFLAGS) $(<) -o $(@)
#
#clean  
.PHONY : clean
clean :
	rm $(OBJDIR)/*
	rm $(EXE)
