/********************************************************************
  APG - an ABNF Parser Generator
  Copyright  (C) 2007 Coast to Coast Research, Inc.
 
  This program is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 2 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program.  If not, see
  <http://www.gnu.org/licenses/old-licenses/gpl-2.0.html>
  or write to the Free Software Foundation, Inc.,
  51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

    author: Lowell Thomas
            lowell@coasttocoastresearch.com
            http://www.coasttocoastresearch.com

   created: 8/28/2007 9:38
  filename: D:\Projects\Apgv5_0\Samples\SIP\Headers.h
   purpose: Defines and declarations for the "headers" component.
  
*********************************************************************/
#ifndef Headers_h_7_12_2007
#define Headers_h_7_12_2007

// some special ASCII character defines
#undef  HTAB
#undef  LF
#undef  CR
#undef  SP
#undef  PERIOD
#undef  SLASH
#undef  COLON
#undef  SEMI
#undef  BACKSLASH
#undef  BUFSIZE
#define HTAB      9
#define LF        10
#define CR        13
#define SP        32
#define PERIOD    46
#define SLASH     47
#define COLON     58
#define SEMI      59
#define BACKSLASH 92
#define BUFSIZE   4096

typedef struct
{
  void*       vpHdrCtx;
  ulong       ulID;
  ulong       ulCount;
  ulong       ulIndex;
  void**      sppHdrFirst;
  APG_BSTR*   spName;
  APG_BSTR*   spValue;
} HDR_ITERATOR;

// the "headers" component
void* vpHdrCtor(void* vpMemCtx);
void  vHdrDtor(void* vpHdrCtx);
void  vHdrClear(void* vpHdrCtx);
ulong ulHdrCatalog(void* vpHdrCtx, APG_BSTR* spMsg);
ulong ulHdrStartLine(void* vpHdrCtx, ulong* ulpType, SIP_REQUEST* spRequest, SIP_RESPONSE* spResponse);
ulong ulHdrBody(void* vpHdrCtx, APG_BSTR* spBody);
ulong ulHdrIterInit(void* vpHdrCtx, HDR_ITERATOR* spIter, ulong ulID);
ulong ulHdrIterIndex(HDR_ITERATOR* spIter, ulong ulIndex);

// some useful utilities
ulong ulHdrQuickScan(APG_BSTR* spMsg, APG_BSTR* spHdrs, APG_BSTR* spBody);
ulong ulHdrQuickScanConvert(APG_BSTR* spMsg, APG_BSTR* spHdrs, APG_BSTR* spBody, APG_BSTR* spScanned);
ulong ulStartLine(APG_BSTR* spMsg, ulong* ulpType, SIP_REQUEST* spRequest, SIP_RESPONSE* spResponse);
int   iCompare(char* cpLeft, char* cpRight, ulong ulLen);


#endif /* Headers_h_7_12_2007 */
