/********************************************************************
  APG - an ABNF Parser Generator
  Copyright  (C) 2007 Coast to Coast Research, Inc.
 
  This program is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 2 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program.  If not, see
  <http://www.gnu.org/licenses/old-licenses/gpl-2.0.html>
  or write to the Free Software Foundation, Inc.,
  51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
  
	 created: Fri Nov 23 10:13:23 2007
	filename: SIPPPTLazy.h
	  author: Lowell Thomas
	          lowell@coasttocoastresearch.com
	          http://www.coasttocoastresearch.com

	 purpose: Header file for parser SIPPPTLazy.

*********************************************************************/
#ifndef SIPPPTLazy_h
#define SIPPPTLazy_h

//{{header.pre
//}}header.pre

// rule name IDs
#define RULE_SIPPPTLAZY_SIP_MESSAGE 0
#define RULE_SIPPPTLAZY_REQUEST 1
#define RULE_SIPPPTLAZY_REQUEST_LINE 2
#define RULE_SIPPPTLAZY_SIP_VERSION 3
#define RULE_SIPPPTLAZY_INVITEM 4
#define RULE_SIPPPTLAZY_ACKM 5
#define RULE_SIPPPTLAZY_OPTIONSM 6
#define RULE_SIPPPTLAZY_BYEM 7
#define RULE_SIPPPTLAZY_CANCELM 8
#define RULE_SIPPPTLAZY_REGISTERM 9
#define RULE_SIPPPTLAZY_METHOD 10
#define RULE_SIPPPTLAZY_EXTENSION_METHOD 11
#define RULE_SIPPPTLAZY_RESPONSE 12
#define RULE_SIPPPTLAZY_STATUS_LINE 13
#define RULE_SIPPPTLAZY_STATUS_CODE 14
#define RULE_SIPPPTLAZY_REASON_PHRASE 15
#define RULE_SIPPPTLAZY_SIP_URI 16
#define RULE_SIPPPTLAZY_SIPS_URI 17
#define RULE_SIPPPTLAZY_USERINFO 18
#define RULE_SIPPPTLAZY_USER 19
#define RULE_SIPPPTLAZY_USER_UNRESERVED 20
#define RULE_SIPPPTLAZY_PASSWORD 21
#define RULE_SIPPPTLAZY_HOSTPORT 22
#define RULE_SIPPPTLAZY_HOST 23
#define RULE_SIPPPTLAZY_HOSTNAME 24
#define RULE_SIPPPTLAZY_DOMAINLABEL 25
#define RULE_SIPPPTLAZY_TOPLABEL 26
#define RULE_SIPPPTLAZY_PORT 27
#define RULE_SIPPPTLAZY_URI_PARAMETERS 28
#define RULE_SIPPPTLAZY_URI_PARAMETER 29
#define RULE_SIPPPTLAZY_TRANSPORT_PARAM 30
#define RULE_SIPPPTLAZY_OTHER_TRANSPORT 31
#define RULE_SIPPPTLAZY_USER_PARAM 32
#define RULE_SIPPPTLAZY_OTHER_USER 33
#define RULE_SIPPPTLAZY_METHOD_PARAM 34
#define RULE_SIPPPTLAZY_TTL_PARAM 35
#define RULE_SIPPPTLAZY_MADDR_PARAM 36
#define RULE_SIPPPTLAZY_LR_PARAM 37
#define RULE_SIPPPTLAZY_OTHER_PARAM 38
#define RULE_SIPPPTLAZY_PNAME 39
#define RULE_SIPPPTLAZY_PVALUE 40
#define RULE_SIPPPTLAZY_PARAMCHAR 41
#define RULE_SIPPPTLAZY_PARAM_UNRESERVED 42
#define RULE_SIPPPTLAZY_HEADERS 43
#define RULE_SIPPPTLAZY_HEADER 44
#define RULE_SIPPPTLAZY_HNAME 45
#define RULE_SIPPPTLAZY_HVALUE 46
#define RULE_SIPPPTLAZY_HNV_UNRESERVED 47
#define RULE_SIPPPTLAZY_REQUEST_URI 48
#define RULE_SIPPPTLAZY_ABSOLUTEURI 49
#define RULE_SIPPPTLAZY_HIER_PART 50
#define RULE_SIPPPTLAZY_NET_PATH 51
#define RULE_SIPPPTLAZY_ABS_PATH 52
#define RULE_SIPPPTLAZY_OPAQUE_PART 53
#define RULE_SIPPPTLAZY_URIC 54
#define RULE_SIPPPTLAZY_URIC_NO_SLASH 55
#define RULE_SIPPPTLAZY_PATH_SEGMENTS 56
#define RULE_SIPPPTLAZY_SEGMENT 57
#define RULE_SIPPPTLAZY_PARAM 58
#define RULE_SIPPPTLAZY_PCHAR 59
#define RULE_SIPPPTLAZY_SCHEME 60
#define RULE_SIPPPTLAZY_AUTHORITY 61
#define RULE_SIPPPTLAZY_SRVR 62
#define RULE_SIPPPTLAZY_REG_NAME 63
#define RULE_SIPPPTLAZY_QUERY 64
#define RULE_SIPPPTLAZY_IPV4ADDRESS 65
#define RULE_SIPPPTLAZY_IPV6REFERENCE 66
#define RULE_SIPPPTLAZY_IPV6ADDRESS 67
#define RULE_SIPPPTLAZY_MESSAGE_HEADER 68
#define RULE_SIPPPTLAZY_ACCEPT 69
#define RULE_SIPPPTLAZY_ACCEPT_RANGE 70
#define RULE_SIPPPTLAZY_MEDIA_RANGE 71
#define RULE_SIPPPTLAZY_ACCEPT_PARAM 72
#define RULE_SIPPPTLAZY_QVALUE 73
#define RULE_SIPPPTLAZY_GENERIC_PARAM 74
#define RULE_SIPPPTLAZY_GEN_VALUE 75
#define RULE_SIPPPTLAZY_ACCEPT_ENCODING 76
#define RULE_SIPPPTLAZY_ENCODING 77
#define RULE_SIPPPTLAZY_CODINGS 78
#define RULE_SIPPPTLAZY_CONTENT_CODING 79
#define RULE_SIPPPTLAZY_ACCEPT_LANGUAGE 80
#define RULE_SIPPPTLAZY_LANGUAGE 81
#define RULE_SIPPPTLAZY_LANGUAGE_RANGE 82
#define RULE_SIPPPTLAZY_ALERT_INFO 83
#define RULE_SIPPPTLAZY_ALERT_PARAM 84
#define RULE_SIPPPTLAZY_ALLOW 85
#define RULE_SIPPPTLAZY_AUTHORIZATION 86
#define RULE_SIPPPTLAZY_CREDENTIALS 87
#define RULE_SIPPPTLAZY_DIGEST_RESPONSE 88
#define RULE_SIPPPTLAZY_DIG_RESP 89
#define RULE_SIPPPTLAZY_USERNAME 90
#define RULE_SIPPPTLAZY_USERNAME_VALUE 91
#define RULE_SIPPPTLAZY_DIGEST_URI 92
#define RULE_SIPPPTLAZY_DIGEST_URI_VALUE 93
#define RULE_SIPPPTLAZY_MESSAGE_QOP 94
#define RULE_SIPPPTLAZY_CNONCE 95
#define RULE_SIPPPTLAZY_CNONCE_VALUE 96
#define RULE_SIPPPTLAZY_NONCE_COUNT 97
#define RULE_SIPPPTLAZY_NC_VALUE 98
#define RULE_SIPPPTLAZY_DRESPONSE 99
#define RULE_SIPPPTLAZY_REQUEST_DIGEST 100
#define RULE_SIPPPTLAZY_AUTH_PARAM 101
#define RULE_SIPPPTLAZY_AUTH_PARAM_NAME 102
#define RULE_SIPPPTLAZY_OTHER_RESPONSE 103
#define RULE_SIPPPTLAZY_AUTH_SCHEME 104
#define RULE_SIPPPTLAZY_AUTHENTICATION_INFO 105
#define RULE_SIPPPTLAZY_AINFO 106
#define RULE_SIPPPTLAZY_NEXTNONCE 107
#define RULE_SIPPPTLAZY_RESPONSE_AUTH 108
#define RULE_SIPPPTLAZY_RESPONSE_DIGEST 109
#define RULE_SIPPPTLAZY_CALL_ID 110
#define RULE_SIPPPTLAZY_CALLID 111
#define RULE_SIPPPTLAZY_CALL_INFO 112
#define RULE_SIPPPTLAZY_INFO 113
#define RULE_SIPPPTLAZY_INFO_PARAM 114
#define RULE_SIPPPTLAZY_CONTACT 115
#define RULE_SIPPPTLAZY_CONTACT_PARAM 116
#define RULE_SIPPPTLAZY_NAME_ADDR 117
#define RULE_SIPPPTLAZY_ADDR_SPEC 118
#define RULE_SIPPPTLAZY_DISPLAY_NAME 119
#define RULE_SIPPPTLAZY_D_NAME 120
#define RULE_SIPPPTLAZY_CONTACT_PARAMS 121
#define RULE_SIPPPTLAZY_C_P_Q 122
#define RULE_SIPPPTLAZY_C_P_EXPIRES 123
#define RULE_SIPPPTLAZY_CONTACT_EXTENSION 124
#define RULE_SIPPPTLAZY_DELTA_SECONDS 125
#define RULE_SIPPPTLAZY_CONTENT_DISPOSITION 126
#define RULE_SIPPPTLAZY_DISP_TYPE 127
#define RULE_SIPPPTLAZY_DISP_PARAM 128
#define RULE_SIPPPTLAZY_HANDLING_PARAM 129
#define RULE_SIPPPTLAZY_OTHER_HANDLING 130
#define RULE_SIPPPTLAZY_DISP_EXTENSION_TOKEN 131
#define RULE_SIPPPTLAZY_CONTENT_ENCODING 132
#define RULE_SIPPPTLAZY_CONTENT_LANGUAGE 133
#define RULE_SIPPPTLAZY_LANGUAGE_TAG 134
#define RULE_SIPPPTLAZY_PRIMARY_TAG 135
#define RULE_SIPPPTLAZY_SUBTAG 136
#define RULE_SIPPPTLAZY_CONTENT_LENGTH 137
#define RULE_SIPPPTLAZY_CONTENT_TYPE 138
#define RULE_SIPPPTLAZY_MEDIA_TYPE 139
#define RULE_SIPPPTLAZY_M_TYPE 140
#define RULE_SIPPPTLAZY_DISCRETE_TYPE 141
#define RULE_SIPPPTLAZY_COMPOSITE_TYPE 142
#define RULE_SIPPPTLAZY_EXTENSION_TOKEN 143
#define RULE_SIPPPTLAZY_IETF_TOKEN 144
#define RULE_SIPPPTLAZY_X_TOKEN 145
#define RULE_SIPPPTLAZY_M_SUBTYPE 146
#define RULE_SIPPPTLAZY_IANA_TOKEN 147
#define RULE_SIPPPTLAZY_M_PARAMETER 148
#define RULE_SIPPPTLAZY_M_ATTRIBUTE 149
#define RULE_SIPPPTLAZY_M_VALUE 150
#define RULE_SIPPPTLAZY_CSEQ 151
#define RULE_SIPPPTLAZY_DATE 152
#define RULE_SIPPPTLAZY_SIP_DATE 153
#define RULE_SIPPPTLAZY_RFC1123_DATE 154
#define RULE_SIPPPTLAZY_DATE1 155
#define RULE_SIPPPTLAZY_TIME 156
#define RULE_SIPPPTLAZY_WKDAY 157
#define RULE_SIPPPTLAZY_MONTH 158
#define RULE_SIPPPTLAZY_ERROR_INFO 159
#define RULE_SIPPPTLAZY_ERROR_URI 160
#define RULE_SIPPPTLAZY_EXPIRES 161
#define RULE_SIPPPTLAZY_FROM 162
#define RULE_SIPPPTLAZY_FROM_SPEC 163
#define RULE_SIPPPTLAZY_FROM_PARAM 164
#define RULE_SIPPPTLAZY_TAG_PARAM 165
#define RULE_SIPPPTLAZY_IN_REPLY_TO 166
#define RULE_SIPPPTLAZY_MAX_FORWARDS 167
#define RULE_SIPPPTLAZY_MIME_VERSION 168
#define RULE_SIPPPTLAZY_MIN_EXPIRES 169
#define RULE_SIPPPTLAZY_ORGANIZATION 170
#define RULE_SIPPPTLAZY_PRIORITY 171
#define RULE_SIPPPTLAZY_PRIORITY_VALUE 172
#define RULE_SIPPPTLAZY_OTHER_PRIORITY 173
#define RULE_SIPPPTLAZY_PROXY_AUTHENTICATE 174
#define RULE_SIPPPTLAZY_CHALLENGE 175
#define RULE_SIPPPTLAZY_OTHER_CHALLENGE 176
#define RULE_SIPPPTLAZY_DIGEST_CLN 177
#define RULE_SIPPPTLAZY_REALM 178
#define RULE_SIPPPTLAZY_REALM_VALUE 179
#define RULE_SIPPPTLAZY_DOMAIN 180
#define RULE_SIPPPTLAZY_URI 181
#define RULE_SIPPPTLAZY_NONCE 182
#define RULE_SIPPPTLAZY_NONCE_VALUE 183
#define RULE_SIPPPTLAZY_OPAQUE 184
#define RULE_SIPPPTLAZY_STALE 185
#define RULE_SIPPPTLAZY_ALGORITHM 186
#define RULE_SIPPPTLAZY_QOP_OPTIONS 187
#define RULE_SIPPPTLAZY_QOP_VALUE 188
#define RULE_SIPPPTLAZY_PROXY_AUTHORIZATION 189
#define RULE_SIPPPTLAZY_PROXY_REQUIRE 190
#define RULE_SIPPPTLAZY_OPTION_TAG 191
#define RULE_SIPPPTLAZY_RECORD_ROUTE 192
#define RULE_SIPPPTLAZY_REC_ROUTE 193
#define RULE_SIPPPTLAZY_RR_PARAM 194
#define RULE_SIPPPTLAZY_REPLY_TO 195
#define RULE_SIPPPTLAZY_RPLYTO_SPEC 196
#define RULE_SIPPPTLAZY_RPLYTO_PARAM 197
#define RULE_SIPPPTLAZY_REQUIRE 198
#define RULE_SIPPPTLAZY_RETRY_AFTER 199
#define RULE_SIPPPTLAZY_RETRY_PARAM 200
#define RULE_SIPPPTLAZY_ROUTE 201
#define RULE_SIPPPTLAZY_ROUTE_PARAM 202
#define RULE_SIPPPTLAZY_SERVER 203
#define RULE_SIPPPTLAZY_SERVER_VAL 204
#define RULE_SIPPPTLAZY_PRODUCT 205
#define RULE_SIPPPTLAZY_PRODUCT_VERSION 206
#define RULE_SIPPPTLAZY_SUBJECT 207
#define RULE_SIPPPTLAZY_SUPPORTED 208
#define RULE_SIPPPTLAZY_TIMESTAMP 209
#define RULE_SIPPPTLAZY_DELAY 210
#define RULE_SIPPPTLAZY_TO 211
#define RULE_SIPPPTLAZY_TO_PARAM 212
#define RULE_SIPPPTLAZY_UNSUPPORTED 213
#define RULE_SIPPPTLAZY_USER_AGENT 214
#define RULE_SIPPPTLAZY_VIA 215
#define RULE_SIPPPTLAZY_VIA_PARM 216
#define RULE_SIPPPTLAZY_VIA_PARAMS 217
#define RULE_SIPPPTLAZY_VIA_TTL 218
#define RULE_SIPPPTLAZY_VIA_MADDR 219
#define RULE_SIPPPTLAZY_VIA_RECEIVED 220
#define RULE_SIPPPTLAZY_VIA_BRANCH 221
#define RULE_SIPPPTLAZY_VIA_EXTENSION 222
#define RULE_SIPPPTLAZY_SENT_PROTOCOL 223
#define RULE_SIPPPTLAZY_PROTOCOL_NAME 224
#define RULE_SIPPPTLAZY_PROTOCOL_VERSION 225
#define RULE_SIPPPTLAZY_TRANSPORT 226
#define RULE_SIPPPTLAZY_SENT_BY 227
#define RULE_SIPPPTLAZY_TTL 228
#define RULE_SIPPPTLAZY_WARNING 229
#define RULE_SIPPPTLAZY_WARNING_VALUE 230
#define RULE_SIPPPTLAZY_WARN_CODE 231
#define RULE_SIPPPTLAZY_WARN_AGENT 232
#define RULE_SIPPPTLAZY_WARN_TEXT 233
#define RULE_SIPPPTLAZY_PSEUDONYM 234
#define RULE_SIPPPTLAZY_WWW_AUTHENTICATE 235
#define RULE_SIPPPTLAZY_EXTENSION_HEADER 236
#define RULE_SIPPPTLAZY_HEADER_NAME 237
#define RULE_SIPPPTLAZY_HEADER_VALUE 238
#define RULE_SIPPPTLAZY_TELEPHONE_SUBSCRIBER 239
#define RULE_SIPPPTLAZY_GLOBAL_PHONE_NUMBER 240
#define RULE_SIPPPTLAZY_BASE_PHONE_NUMBER 241
#define RULE_SIPPPTLAZY_LOCAL_PHONE_NUMBER 242
#define RULE_SIPPPTLAZY_ISDN_SUBADDRESS 243
#define RULE_SIPPPTLAZY_POST_DIAL 244
#define RULE_SIPPPTLAZY_AREA_SPECIFIER 245
#define RULE_SIPPPTLAZY_PHONE_CONTEXT_TAG 246
#define RULE_SIPPPTLAZY_PHONE_CONTEXT_IDENT 247
#define RULE_SIPPPTLAZY_NETWORK_PREFIX 248
#define RULE_SIPPPTLAZY_GLOBAL_NETWORK_PREFIX 249
#define RULE_SIPPPTLAZY_LOCAL_NETWORK_PREFIX 250
#define RULE_SIPPPTLAZY_PRIVATE_PREFIX 251
#define RULE_SIPPPTLAZY_SERVICE_PROVIDER 252
#define RULE_SIPPPTLAZY_PROVIDER_TAG 253
#define RULE_SIPPPTLAZY_PROVIDER_HOSTNAME 254
#define RULE_SIPPPTLAZY_FUTURE_EXTENSION 255
#define RULE_SIPPPTLAZY_TOKEN_CHAR 256
#define RULE_SIPPPTLAZY_TEL_QUOTED_STRING 257
#define RULE_SIPPPTLAZY_PHONEDIGIT 258
#define RULE_SIPPPTLAZY_RFC1035DOMAIN 259
#define RULE_SIPPPTLAZY_RFC1035SUBDOMAIN 260
#define RULE_SIPPPTLAZY_RFC1035LABEL 261
#define RULE_SIPPPTLAZY_ALPHANUM 262
#define RULE_SIPPPTLAZY_RESERVED 263
#define RULE_SIPPPTLAZY_UNRESERVED 264
#define RULE_SIPPPTLAZY_ESCAPED 265
#define RULE_SIPPPTLAZY_TEXT_UTF8_TRIM 266
#define RULE_SIPPPTLAZY_TEXT_UTF8CHAR 267
#define RULE_SIPPPTLAZY_UTF8_NONASCII 268
#define RULE_SIPPPTLAZY_UTF8_CONT 269
#define RULE_SIPPPTLAZY_TOKEN 270
#define RULE_SIPPPTLAZY_WORD 271
#define RULE_SIPPPTLAZY_HCOLON 272
#define RULE_SIPPPTLAZY_LHEX 273
#define RULE_SIPPPTLAZY_STAR 274
#define RULE_SIPPPTLAZY_SLASH 275
#define RULE_SIPPPTLAZY_EQUAL 276
#define RULE_SIPPPTLAZY_LPAREN 277
#define RULE_SIPPPTLAZY_RPAREN 278
#define RULE_SIPPPTLAZY_RAQUOT 279
#define RULE_SIPPPTLAZY_LAQUOT 280
#define RULE_SIPPPTLAZY_COMMA 281
#define RULE_SIPPPTLAZY_SEMI 282
#define RULE_SIPPPTLAZY_COLON 283
#define RULE_SIPPPTLAZY_LDQUOT 284
#define RULE_SIPPPTLAZY_RDQUOT 285
#define RULE_SIPPPTLAZY_COMMENT 286
#define RULE_SIPPPTLAZY_CTEXT 287
#define RULE_SIPPPTLAZY_QUOTED_STRING 288
#define RULE_SIPPPTLAZY_Q_STRING 289
#define RULE_SIPPPTLAZY_QDTEXT 290
#define RULE_SIPPPTLAZY_QUOTED_PAIR 291
#define RULE_SIPPPTLAZY_LWS 292
#define RULE_SIPPPTLAZY_SWS 293
#define RULE_SIPPPTLAZY_WSP 294
#define RULE_SIPPPTLAZY_ALPHA 295
#define RULE_SIPPPTLAZY_CHAR 296
#define RULE_SIPPPTLAZY_CR 297
#define RULE_SIPPPTLAZY_CRLF 298
#define RULE_SIPPPTLAZY_DIGIT 299
#define RULE_SIPPPTLAZY_DQUOTE 300
#define RULE_SIPPPTLAZY_HEXDIG 301
#define RULE_SIPPPTLAZY_LF 302
#define RULE_SIPPPTLAZY_SP 303

extern void* vpSIPPPTLazyInit;

//{{header.post
//}}header.post

#endif // SIPPPTLazy_h
