/********************************************************************
  APG - an ABNF Parser Generator
  Copyright  (C) 2007 Coast to Coast Research, Inc.
 
  This program is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 2 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program.  If not, see
  <http://www.gnu.org/licenses/old-licenses/gpl-2.0.html>
  or write to the Free Software Foundation, Inc.,
  51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

    author: Lowell Thomas
            lowell@coasttocoastresearch.com
            http://www.coasttocoastresearch.com

   created: 8/27/2007 9:04
  filename: D:\Projects\Apgv5_0\Samples\URI\main.h
   purpose: Common header file for all modules.
  
*********************************************************************/
#ifndef main_h_6_13_2007
#define main_h_6_13_2007

#include <stdio.h>
#include "Apg.h"
#include "ApgUtilities.h"
#include "URI.h"

#define MAINASSERT(cond) if(!(int)(cond))vAlertHandler(0, __LINE__, __FILE__)

typedef struct
{
  // input
  void* vpMemCtx;
  void* vpMsgs;
  char* cpTitle;
  ulong ulRepetitions;
  void* vpInit;

  // output
  APG_PARSER_STATS sStats;
  double dAddressPerMsec;
  double dCharactersPerMsec;
} TESTDATA;

// Accuracy.c
void    vTestAccuracy(void* vpMemCtx, char* cpFileName);
void    vRunAccuracy(TESTDATA* spData);
void    vTestPrintStats(APG_PARSER_STATS* spStats);

// LookAhead.c
void    vTestLookAhead(void* vpMemCtx, char* cpFileName);
void    vRunLookAhead(TESTDATA* spData);

// Timing.c
void    vTestTiming(void* vpMemCtx, char* cpFileName);
void    vRunTiming(TESTDATA* spData);

// ReadUris.c
ulong   ulReadUris(APG_BSTR* spSrc, void* vpBstr);


#endif /* main_h_6_13_2007 */
