/*! \file LSCrouch.h
 <pre>
 <b>File:</b> LSCrouch.h
 <b>Project:</b> Robocup 3D
 <b>Authors:</b> Hviezdna Jedenastka
 <b>Created:</b> 04/13/2008
 <b>Contents:</b> Calculate crouch with hand stabilisation
 </pre>
 */ 

#ifndef __LSCROUCH_H__
#define __LSCROUCH_H__

#include "Skills.h"
#include "PlayerModel.h"
#include "WorldModel.h"

class LSCrouch: public LowSkill {
    
private:
	
	double speedRatio;
	double ankle;
	double knee;
	double hip;
    
	int calculateCrouch(double _ankle);
    
public:
    
	LSCrouch(WorldModel * _world, PlayerModel * _player, double _speedRatio, double _ankle);
    
	int skillType();
	int calculate(Skill **lowerSkill);
};

#endif /*__LSCROUCH_H__*/
