/*! \file MSKneeBenting.cpp
 <pre>
 <b>File:</b> MSKneeBenting.cpp
 <b>Project:</b> Robocup 3D
 <b>Authors:</b> Hviezdna Jedenastka
 <b>Created:</b> 03/10/2008
 <b>Contents:</b>
 </pre>
 */

#include "MSKneeBenting.h"
#include "LSCrouch.h"
#include "LSStand.h"

MSKneeBenting::MSKneeBenting(WorldModel * _world, PlayerModel * _player):MiddleSkill(_world, _player) {
    
    lastLS = SKILL_LS_STAND;
}

int MSKneeBenting::skillType() {
    
    return SKILL_MS_KNEEBENTING;
}

int MSKneeBenting::calculate(Skill ** lowerSkill) {
    
    if (lowerSkill != NULL && *lowerSkill != NULL)
        return 1;
    
    if (lastLS == SKILL_LS_STAND) {
        
        *lowerSkill = new LSCrouch(world, player, 3.0, 75.0);
        
    } else {
        
        *lowerSkill = new LSStand(world, player, 3.0);
    }
    
    lastLS = (*lowerSkill)->skillType();
    return 1;
}
