/*! \file Walk.cpp
 <pre>
 <b>File:</b> Walk.cpp
 <b>Project:</b> Robocup 3D
 <b>Authors:</b> Hviezdna Jedenastka
 <b>Created:</b> 03/10/2008
 <b>Contents:</b>
 </pre>
 */

#include "MSWalk.h"
#include "LSStep.h"

MSWalk::MSWalk(WorldModel * _world, PlayerModel * _player):MiddleSkill(_world, _player) {
}

int MSWalk::skillType() {
    
    return SKILL_MS_WALK;
}

int MSWalk::calculate(Skill ** lowerSkill) {
    
    if (lowerSkill != NULL && *lowerSkill != NULL)
        return 1;
    
    /* TODO: check if player is standing on the ground */
    *lowerSkill = new LSStep(world, player);
    
    lastLS = (*lowerSkill)->skillType();
    return 1;
}
