/*! \file ForceResistance.h
 <pre>
 <b>File:</b> ForceResistance.h
 <b>Project:</b> Robocup 3D
 <b>Authors:</b> Hviezdna Jedenastka
 <b>Created:</b> 04/13/2008
 <b>Contents:</b> This class represents force resistance perceptor.
 </pre>
 */

#ifndef FORCE_RESISTANCE_H_
#define FORCE_RESISTANCE_H_

#include "CoordCartesian.h"

/*
 Implementation of ForceResistance perceptor
 */
class ForceResistance {
	
public:
    
	CoordCartesian LocCoord_LF;				//local coordinates of the force concentration point - for left foot 
	CoordCartesian LocCoord_RF;				//the same for right foot
	CoordCartesian ForceVector_LF;			//force vector for left foot
	CoordCartesian ForceVector_RF;			//force vector for right foot
    
public:
	
	ForceResistance();
	~ForceResistance();
    
	/*!< Updates ForceResistance in playermodel */
	void update(CoordCartesian LocCoord_LF_, CoordCartesian LocCoord_RF_, CoordCartesian ForceVector_LF_, CoordCartesian ForceVector_RF_);
};

#endif /*FORCE_RESISTANCE_H_*/
