/*! \file CoordSpherical.h
 <pre>
 <b>File:</b> CoordSpherical.h
 <b>Project:</b> Robocup 3D
 <b>Authors:</b> Hviezdna Jedenastka
 <b>Created:</b> 03/11/2008
 <b>Contents:</b> This class represents spherical coordinations and provides useful conversion methods.
 </pre>
 */

#ifndef __COORDSPHERICAL_H__
#define __COORDSPHERICAL_H__

#include "CoordCartesian.h"
#include <iostream>
#include <math.h>

using namespace std;

class CoordCartesian;

class CoordSpherical {
    
private:
    
	/*!< conversion method */
	void fromCartesian(double x, double y, double z);
    
public:
    
	double r;		/*!< radial distance */
	double theta;	/*!< angle 1 - zenith */
	double phi;		/*!< angle 2 - azimuth */
    
	CoordSpherical();	
	~CoordSpherical();
    
	CoordSpherical(double _r, double _theta, double _phi);	
	CoordSpherical(const CoordCartesian& cartesian);
    
	/*!< overloaded operators */
	CoordSpherical& operator = (const CoordSpherical& spherical);
	CoordSpherical& operator = (const CoordCartesian& cartesian);	
	friend ostream& operator << (ostream& outStream, const CoordSpherical& spherical);
};

#endif /*__COORDSPHERICAL_H__*/
